﻿//==========================================================
//	linksim-draw.js by LinkSim for Web
//==========================================================
/*
11: '円盤（小）／動力付き'
12: '円盤（中）／動力付き'
13: '円盤（大）／動力付き'
15: 'ロッド１ ／動力付き'
16: 'ロッド２ ／動力付き'

21: '円盤（小）'
22: '円盤（中）'
23: '円盤（大）'
31: 'ロッド（L='
32: 'ロッド（L='
33: 'ロッド（L='
34: 'ロッド（L='
35: 'ロッド（L='
36: 'ロッド（L='
41: '三角形（小）'
42: '三角形（大）'
43: '三角形（大）'
54: 'Ｌ型（小）'
52: 'Ｌ型（中）'
53: 'Ｌ型（大）'
91: 'ピストン／動力付き'
92: 'ピストン';
93: 'ピストン（短）／動力付き'
94: 'ピストン（短）'
95: 'スライドロッド（長）'
96: 'スライドロッド（短）'
*/
//#####################################################################
//	イメージ全体の処理
//#####################################################################

//=============================================================
//	canvasのクリア（Canvasクリア後、グリッド表示）
//=============================================================
//----------------------------------------------------------
//	canvasイメージの消去（グリッドの表示を含む）
//----------------------------------------------------------
//procedure Clear_imgTemp()
function clearCanvas() {
	var background = new Image();
	background.src = "./img/grid.png";

	background.onload = function(){
		var pattern = context.createPattern(background, 'repeat');
		context.fillStyle = pattern;
		context.fillRect(0, 0, canvas.width, canvas.height);
	}
	
	contextPos.fillStyle = "rgb(255, 255, 255)";
	contextPos.fillRect(0, 0, canvas.width, canvas.height);
}

//----------------------------------------------------------
//  canvasイメージの再描画
//----------------------------------------------------------
//procedure ReDraw_imgTemp();
function redrawCanvas() {
	contextPos.fillStyle = "rgb(255, 255, 255)";
	contextPos.fillRect(0, 0, canvas.width, canvas.height);

	var background = new Image();
	background.src = "./img/grid.png";

	background.onload = function(){
		var pattern = context.createPattern(background, 'repeat');
		context.fillStyle = pattern;
		context.fillRect(0, 0, canvas.width, canvas.height);
		
		redrawCanvas2();
	}
}
//---------------------------------
function redrawCanvas2() {
	var idx;

	drawKiseki();       //軌跡の描画

	//---------------------------------
	//下層側から順に描画
	//---------------------------------
	//透過イメージは、後回し（前面表示）
	//動力ピストンを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power") && parts[idx].transparent == false && parts[idx].visible == true){
			drawPiston(idx);
		}
	}

	//動力ロッドを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawRod(idx);
		}
	}

	//円盤（動力円盤を含む）を通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power"|| parts[idx].kind == "disk3Power" || parts[idx].kind == "disk1" || parts[idx].kind == "disk2"|| parts[idx].kind == "disk3") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawDisk(idx);
		}
	}

	//三角を通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "triangle1" || parts[idx].kind == "triangle2") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawTriangle(idx);
		}
	}

	//非動力ロッドを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rod1" || parts[idx].kind == "rod2" || parts[idx].kind == "rod3" || parts[idx].kind == "rod4" || parts[idx].kind == "rod5" || parts[idx].kind == "rod6") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawRod(idx);
		}
	}

	//非動力ピストンを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "piston1" || parts[idx].kind == "piston2") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawPiston(idx);
		}
	}

	//スライドロッドを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rodSlide1" || parts[idx].kind == "rodSlide2") && parts[idx].transparent == false && parts[idx].visible == true) {
			drawRodSlide(idx);
		}
	}

	//-----------------------------------------
	//透過イメージを表示
	//-----------------------------------------
	//動力ピストンを透過描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawPiston(idx);
		}
	}

	//動力ロッドを透過描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawRod(idx);
		}
	}

	//円盤（動力円盤を含む）を透過描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power"|| parts[idx].kind == "disk3Power" || parts[idx].kind == "disk1" || parts[idx].kind == "disk2"|| parts[idx].kind == "disk3") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawDisk(idx);
		}
	}

	//三角を透過描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "triangle1" || parts[idx].kind == "triangle2") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawTriangle(idx);
		}
	}

	//非動力ロッドを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rod1" || parts[idx].kind == "rod2" || parts[idx].kind == "rod3" || parts[idx].kind == "rod4" || parts[idx].kind == "rod5" || parts[idx].kind == "rod6") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawRod(idx);
		}
	}

	//非動力ピストンを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "piston1" || parts[idx].kind == "piston2") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawPiston(idx);
		}
	}

	//スライドロッドを通常描画
	for (idx = 0; idx < partsCount; idx++) {
		if ((parts[idx].kind == "rodSlide1" || parts[idx].kind == "rodSlide2") && parts[idx].transparent == true && parts[idx].visible == true) {
			drawRodSlide(idx);
		}
	}

/*	
	//-----------------------------------------
	//ピンを描画
	for (idx = 0; idx < partsCount; idx++) {
		if (parts[idx].kind > 60) && (parts[idx].visible) then
			Draw_Pin(no);
		}
	}

	//-----------------------------------------
	//ペンを描画
	for (idx = 0; idx < partsCount; idx++) {
		if (parts[idx].kind > 100) && (parts[idx].visible) then
			Draw_Pen(no);
		}
	}
*/

}

//***********************************************************
//  軌跡の描画
//***********************************************************
//procedure Draw_Kiseki();
function drawKiseki() {

	//----------------------------------------------------
	//黒ペン
	//----------------------------------------------------
	if (penBlackListX.length > 1) {
		context.beginPath();
		context.moveTo(penBlackListX[0], penBlackListY[0]);
		for (var i = 1; i < penBlackListX.length-1; i++) {
			context.lineTo(penBlackListX[i], penBlackListY[i]);
		}
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}
	
	//----------------------------------------------------
	//青ペン
	//----------------------------------------------------
	if (penBlueListX.length > 1) {
		context.beginPath();
		context.moveTo(penBlueListX[0], penBlueListY[0]);
		for (var i = 1; i < penBlueListX.length-1; i++) {
			context.lineTo(penBlueListX[i], penBlueListY[i]);
		}
		context.strokeStyle = "blue";
		context.lineWidth = 1;
		context.stroke();
	}

	//----------------------------------------------------
	//赤ペン
	//----------------------------------------------------
	if (penRedListX.length > 1) {
		context.beginPath();
		context.moveTo(penRedListX[0], penRedListY[0]);
		for (var i = 1; i < penRedListX.length-1; i++) {
			context.lineTo(penRedListX[i], penRedListY[i]);
		}
		context.strokeStyle = "red";
		context.lineWidth = 1;
		context.stroke();
	}

	//----------------------------------------------------
	//緑ペン
	//----------------------------------------------------
	if (penGreenListX.length > 1) {
		context.beginPath();
		context.moveTo(penGreenListX[0], penGreenListY[0]);
		for (var i = 1; i < penGreenListX.length-1; i++) {
			context.lineTo(penGreenListX[i], penGreenListY[i]);
		}
		context.strokeStyle = "green";
		context.lineWidth = 1;
		context.stroke();
	}
}

//#####################################################################
//	パーツの描画
//#####################################################################
//----------------------------------------------------------
//  ピンの描画
//----------------------------------------------------------
function addPin(idx) {
	var xD, yD;
	var i;
	var x, y, angle;
	var r, p;

	x = parts[idx].x;
	y = parts[idx].y;
	angle = parts[idx].a;
	r = parts[idx].r;
	
	//91～94 = piston
	if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
		while (r > 360) {
			r = r - 360;
		}
		while (r < 0) {
			r = r + 360;
		}
		if (r > 180) {
			p = 360 - r;
		} else {
			p = r;
		}
	} else {
	    p = 0;
	}

	for (i = 0; i < parts[idx].pinCount; i++) {
		xD = Math.round(rotateX(x, y, x+parts[idx].pinX[i]+p, y+parts[idx].pinY[i], angle));
		yD = Math.round(rotateY(x, y, x+parts[idx].pinX[i]+p, y+parts[idx].pinY[i], angle));

		if (parts[idx].pinType[i] == 0) {
			//formMain.imgTemp.Canvas.Brush.Color := clBlack;
			//formMain.imgTemp.Canvas.Ellipse(xD-8, yD-8, xD+9, yD+9);
			context.beginPath();
			context.arc(xD, yD, 8, 0, 2*Math.PI);
			context.fillStyle = "black";
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();

			//formMain.imgTemp.Canvas.Brush.Color := clLtGray;
			//formMain.imgTemp.Canvas.Ellipse(xD-6, yD-6, xD+7, yD+7);
			context.beginPath();
			context.arc(xD, yD, 6, 0, 2*Math.PI);
			context.fillStyle = "lightgray";
			context.fill();
			context.strokeStyle = "lightgray";
			context.lineWidth = 1;
			context.stroke();

			//formMain.imgTemp.Canvas.Brush.Color := clBlack;
			//formMain.imgTemp.Canvas.Ellipse(xD-2, yD-2, xD+3, yD+3);
			context.beginPath();
			context.arc(xD, yD, 2, 0, 2*Math.PI);
			context.fillStyle = "black";
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();

		} else {
			//formMain.imgTemp.Canvas.Brush.Color := clBlack;
			//formMain.imgTemp.Canvas.Rectangle(xD-8, yD-8, xD+9, yD+9);
			context.beginPath();
			context.rect(xD-8, yD-8, 16, 16);
			context.fillStyle = "black";
			context.fill();
		}
	}
}

//----------------------------------------------------------
//  ペンの描画
//----------------------------------------------------------
function addPen(idx) {
	var xD, yD;
	var i;
	var x, y, angle;
	var cl;
	var r, p;

	x = parts[idx].x;
	y = parts[idx].y;
	angle = parts[idx].a;
	r : parts[idx].r;

	//91～94 = piston
	if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
		while (r > 360) {
			r = r - 360;
		}
		while (r < 0) {
			r = r + 360;
		}
		if (r > 180) {
			p = 360 - r;
		} else {
			p = r;
		}
	} else {
		p = 0;
	}

	for (i = 0; i < parts[idx].penCount; i++) {

		xD = Math.round(rotateX(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle));
		yD = Math.round(rotateY(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle));

		if (parts[idx].penType[i] == "black") {
			pen_1_X = rotateX(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			pen_1_Y = rotateY(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			cl = "black";
		} else if (parts[idx].penType[i] == "blue") {
			pen_2_X = rotateX(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			pen_2_Y = rotateY(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			cl = "blue";
		} else if (parts[idx].penType[i] == "red") {
			pen_3_X = rotateX(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			pen_3_Y = rotateY(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			cl = "red";
		} else if (parts[idx].penType[i] == "green") {
			pen_4_X = rotateX(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			pen_4_Y = rotateY(x, y, x+parts[idx].penX[i]+p, y+parts[idx].penY[i], angle);
			cl = "green";
		}


		//formMain.imgTemp.Canvas.Brush.Style := bsClear;
		//formMain.imgTemp.Canvas.Pen.Width := 2;
		//formMain.imgTemp.Canvas.Pen.Color := cl;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(xD + 0), Round(yD - 11)),
		//Point(Round(xD + 10), Round(yD - 5)),
		//Point(Round(xD + 10), Round(yD + 5)),
		//Point(Round(xD + 0), Round(yD + 11)),
		//Point(Round(xD - 9), Round(yD + 5)),
		//Point(Round(xD - 9), Round(yD - 5)),
		//Point(Round(xD + 0), Round(yD - 11))]);
		context.beginPath();
		context.lineWidth = 2;
		context.strokeStyle = cl;
		context.moveTo(xD + 0, yD -11);
		context.lineTo(xD +10, yD - 5);
		context.lineTo(xD +10, yD + 5);
		context.lineTo(xD + 0, yD +11);
		context.lineTo(xD - 9, yD + 5);
		context.lineTo(xD - 9, yD - 5);
		context.lineTo(xD + 0, yD -11);
		context.stroke();

		//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
		//formMain.imgTemp.Canvas.Brush.Color := cl;
		//formMain.imgTemp.Canvas.Pen.Width := 1;
		//formMain.imgTemp.Canvas.Ellipse(xD-2, yD-2, xD+3, yD+3);
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = cl;
		context.fill();
		context.strokeStyle = cl;
		context.lineWidth = 1;
		context.stroke();

		//後処理
		//formMain.imgTemp.Canvas.Pen.Width := 1;
		//formMain.imgTemp.Canvas.Pen.Color := clBlack;
	}
}

//----------------------------------------------------------
//  円盤の描画
//----------------------------------------------------------
function drawDisk(idx) {
	
	var xD, yD;
	var i;
	var x, y, r, angle;
	var st;

	st = parts[idx].kind;
	x = parts[idx].x;
	y = parts[idx].y;
	r = parts[idx].r;
	angle = parts[idx].a;


	//移動時の表示（輪郭のみ）
	if (parts[idx].transparent == true) {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FFFFFF;
		//formMain.imgTemp.Canvas.Brush.Style := bsClear;
		//formMain.imgTemp.Canvas.Ellipse(Round(x-r), Round(y-r), Round(x+r), Round(y+r));
		
		context.beginPath();
		context.arc(x, y, r, 0, 2*Math.PI);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		
		//連結穴のブラシスタイルの指定
		var holeFillColor = "rgba(255, 255, 255, 0)";

    //通常の表示
	} else {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Ellipse(Round(x-r), Round(y-r), Round(x+r), Round(y+r));

		context.beginPath();
		context.arc(x, y, r, 0, 2*Math.PI);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		//sy < 20 : 動力円盤
		if (st == "disk1Power" || st == "disk2Power" || st == "disk3Power") {
			//formMain.imgTemp.Canvas.Brush.Color := $00808FFF
			context.fillStyle = "rgb(255, 128, 128)";
			context.fill();
		} else {
			//formMain.imgTemp.Canvas.Brush.Color := $00FF8080;
			//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
			context.fillStyle = "rgb(128, 128, 255)";
			context.fill();
		}

		//パーツのidx取得用
		//PositionBitmap.Canvas.Brush.Color := no;
		//PositionBitmap.Canvas.Brush.Style := bsSolid;
		//PositionBitmap.Canvas.Pen.Color := no;
		//PositionBitmap.Canvas.Pen.Style := psSolid;
		//PositionBitmap.Canvas.Ellipse(Round(x-r), Round(y-r), Round(x+r), Round(y+r));
		contextPos.beginPath();
		contextPos.arc(x, y, r, 0, 2*Math.PI);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//連結穴のブラシスタイルの指定
		//formMain.imgTemp.Canvas.Brush.Color := clGray;
		var holeFillColor = "gray";
	}
	
	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	for (i = 0; i <= Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x, y-(i*20+30), angle));
		yD = Math.round(rotateY(x, y, x, y-(i*20+30), angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		xD = Math.round(rotateX(x, y, x, y+(i*20+30), angle));
		yD = Math.round(rotateY(x, y, x, y+(i*20+30), angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}

	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	for (i = 0; i <= Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x-(i*20+20), y, angle));
		yD = Math.round(rotateY(x, y, x-(i*20+20), y, angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		xD = Math.round(rotateX(x, y, x+(i*20+20), y, angle));
		yD = Math.round(rotateY(x, y, x+(i*20+20), y, angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}


	//---------------------------------------------
	//ピンとペンの描画
	//---------------------------------------------
	addPin(idx);
	addPen(idx);
}

//----------------------------------------------------------
//  ピストンの描画
//----------------------------------------------------------
function drawPiston(idx) {
	var i, s;
	var x, y, r, angle;
	var p;
	var X1,  Y1,  X2,  Y2,  X3,  Y3,  X4,  Y4;
	var X5,  Y5,  X6,  Y6,  X7,  Y7,  X8,  Y8;
	var X1D, Y1D, X2D, Y2D, X3D, Y3D, X4D, Y4D;
	var X5D, Y5D, X6D, Y6D, X7D, Y7D, X8D, Y8D;
	var X11,  Y11,  X12,  Y12,  X13,  Y13,  X14,  Y14;
	var X21,  Y21,  X22,  Y22,  X23,  Y23,  X24,  Y24;
	var X31,  Y31,  X32,  Y32,  X33,  Y33,  X34,  Y34;
	var X41,  Y41,  X42,  Y42,  X43,  Y43,  X44,  Y44;
	var X11D,  Y11D,  X12D,  Y12D,  X13D,  Y13D,  X14D,  Y14D;
	var X21D,  Y21D,  X22D,  Y22D,  X23D,  Y23D,  X24D,  Y24D;
	var X31D,  Y31D,  X32D,  Y32D,  X33D,  Y33D,  X34D,  Y34D;
	var X41D,  Y41D,  X42D,  Y42D,  X43D,  Y43D,  X44D,  Y44D;
	var xD, yD;

	x = parts[idx].x;
	y = parts[idx].y;
	r = parts[idx].r;   //ピストンの移動量
	angle = parts[idx].a;

	while (r > 360) {
		r = r - 360;
	}
	while (r < 0) {
		r = r + 360;
	}
	if (r > 180) {
		p = 360 - r;
	} else {
		p = r;
	}

	//外形の位置
	X1  = x + 240;  Y1  = y - 40;
	X2  = x + 240;  Y2  = y - 30;
	X3  = x - 0;    Y3  = y - 30;
	X4  = x - 0;    Y4  = y + 30;
	X5  = x + 240;  Y5  = y + 30;
	X6  = x + 240;  Y6  = y + 40;
	X7  = x - 10;   Y7  = y + 40;
	X8  = x - 10;   Y8  = y - 40;

	//ピストンの位置
	X11 = x + p;      Y11 = y - 30;
	X12 = x + 50 + p; Y12 = y - 30;
	X13 = x + 50 + p; Y13 = y + 30;
	X14 = x + p;      Y14 = y + 30;

	//ロッドの位置(91 or 92)
	if (parts[idx].kind == "piston2Power" || parts[idx].kind == "piston2") {
		X21 = x + 5 + p;   Y21 = y - 10;
		X22 = x + 320 + p; Y22 = y - 10;
		X23 = x + 320 + p; Y23 = y + 10;
		X24 = x + 5 + p;   Y24 = y + 10;
	} else {
		X21 = x + 5 + p;   Y21 = y - 10;
		X22 = x + 140 + p; Y22 = y - 10;
		X23 = x + 140 + p; Y23 = y + 10;
		X24 = x + 5 + p;   Y24 = y + 10;
	}

	//ピストン固定ピン１の位置
	X31 = x - 6 + 20 + p; Y31 = y - 6;
	X32 = x + 6 + 20 + p; Y32 = y - 6;
	X33 = x + 6 + 20 + p; Y33 = y + 6;
	X34 = x - 6 + 20 + p; Y34 = y + 6;

	//ピストン固定ピン２の位置
	X41 = x - 6 + 38 + p; Y41 = y - 6;
	X42 = x + 6 + 38 + p; Y42 = y - 6;
	X43 = x + 6 + 38 + p; Y43 = y + 6;
	X44 = x - 6 + 38 + p; Y44 = y + 6;

	X1D  = Math.round(rotateX(x, y, X1, Y1, angle)); Y1D  = Math.round(rotateY(x, y, X1, Y1, angle));
	X2D  = Math.round(rotateX(x, y, X2, Y2, angle)); Y2D  = Math.round(rotateY(x, y, X2, Y2, angle));
	X3D  = Math.round(rotateX(x, y, X3, Y3, angle)); Y3D  = Math.round(rotateY(x, y, X3, Y3, angle));
	X4D  = Math.round(rotateX(x, y, X4, Y4, angle)); Y4D  = Math.round(rotateY(x, y, X4, Y4, angle));
	X5D  = Math.round(rotateX(x, y, X5, Y5, angle)); Y5D  = Math.round(rotateY(x, y, X5, Y5, angle));
	X6D  = Math.round(rotateX(x, y, X6, Y6, angle)); Y6D  = Math.round(rotateY(x, y, X6, Y6, angle));
	X7D  = Math.round(rotateX(x, y, X7, Y7, angle)); Y7D  = Math.round(rotateY(x, y, X7, Y7, angle));
	X8D  = Math.round(rotateX(x, y, X8, Y8, angle)); Y8D  = Math.round(rotateY(x, y, X8, Y8, angle));

	X11D = Math.round(rotateX(x, y, X11, Y11, angle)); Y11D = Math.round(rotateY(x, y, X11, Y11, angle));
	X12D = Math.round(rotateX(x, y, X12, Y12, angle)); Y12D = Math.round(rotateY(x, y, X12, Y12, angle));
	X13D = Math.round(rotateX(x, y, X13, Y13, angle)); Y13D = Math.round(rotateY(x, y, X13, Y13, angle));
	X14D = Math.round(rotateX(x, y, X14, Y14, angle)); Y14D = Math.round(rotateY(x, y, X14, Y14, angle));

	X21D = Math.round(rotateX(x, y, X21, Y21, angle)); Y21D = Math.round(rotateY(x, y, X21, Y21, angle));
	X22D = Math.round(rotateX(x, y, X22, Y22, angle)); Y22D = Math.round(rotateY(x, y, X22, Y22, angle));
	X23D = Math.round(rotateX(x, y, X23, Y23, angle)); Y23D = Math.round(rotateY(x, y, X23, Y23, angle));
	X24D = Math.round(rotateX(x, y, X24, Y24, angle)); Y24D = Math.round(rotateY(x, y, X24, Y24, angle));

	X31D = Math.round(rotateX(x, y, X31, Y31, angle)); Y31D = Math.round(rotateY(x, y, X31, Y31, angle));
	X32D = Math.round(rotateX(x, y, X32, Y32, angle)); Y32D = Math.round(rotateY(x, y, X32, Y32, angle));
	X33D = Math.round(rotateX(x, y, X33, Y33, angle)); Y33D = Math.round(rotateY(x, y, X33, Y33, angle));
	X34D = Math.round(rotateX(x, y, X34, Y34, angle)); Y34D = Math.round(rotateY(x, y, X34, Y34, angle));

	X41D = Math.round(rotateX(x, y, X41, Y41, angle)); Y41D = Math.round(rotateY(x, y, X41, Y41, angle));
	X42D = Math.round(rotateX(x, y, X42, Y42, angle)); Y42D = Math.round(rotateY(x, y, X42, Y42, angle));
	X43D = Math.round(rotateX(x, y, X43, Y43, angle)); Y43D = Math.round(rotateY(x, y, X43, Y43, angle));
	X44D = Math.round(rotateX(x, y, X44, Y44, angle)); Y44D = Math.round(rotateY(x, y, X44, Y44, angle));

	//移動時の表示（輪郭のみ）
	if (parts[idx].transparent == true) {
		//formMain.imgTemp.Canvas.Brush.Color := $00FFFFFF;
		//formMain.imgTemp.Canvas.Brush.Style := bsClear;

		//外形の描画
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X5D), Round(Y5D)),
		//                               Point(Round(X6D), Round(Y6D)),
		//                               Point(Round(X7D), Round(Y7D)),
		//                               Point(Round(X8D), Round(Y8D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X5D, Y5D);
		context.lineTo(X6D, Y6D);
		context.lineTo(X7D, Y7D);
		context.lineTo(X8D, Y8D);
		context.lineTo(X1D, Y1D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//ピストンの描画
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X11D), Round(Y11D)),
		//                               Point(Round(X12D), Round(Y12D)),
		//                               Point(Round(X13D), Round(Y13D)),
		//                               Point(Round(X14D), Round(Y14D)),
		//                               Point(Round(X11D), Round(Y11D))]);
		context.beginPath();
		context.moveTo(X11D, Y11D);
		context.lineTo(X12D, Y12D);
		context.lineTo(X13D, Y13D);
		context.lineTo(X14D, Y14D);
		context.lineTo(X11D, Y11D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//ロッドの描画
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X21D), Round(Y21D)),
		//                               Point(Round(X22D), Round(Y22D)),
		//                               Point(Round(X23D), Round(Y23D)),
		//                               Point(Round(X24D), Round(Y24D)),
		//                               Point(Round(X21D), Round(Y21D))]);
		context.beginPath();
		context.moveTo(X21D, Y21D);
		context.lineTo(X22D, Y22D);
		context.lineTo(X23D, Y23D);
		context.lineTo(X24D, Y24D);
		context.lineTo(X21D, Y21D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//ピストン固定ピンの描画
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X31D), Round(Y31D)),
		//                               Point(Round(X32D), Round(Y32D)),
		//                               Point(Round(X33D), Round(Y33D)),
		//                               Point(Round(X34D), Round(Y34D)),
		//                               Point(Round(X31D), Round(Y31D))]);
		context.beginPath();
		context.moveTo(X31D, Y31D);
		context.lineTo(X32D, Y32D);
		context.lineTo(X33D, Y33D);
		context.lineTo(X34D, Y34D);
		context.lineTo(X31D, Y31D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X41D), Round(Y41D)),
		//                               Point(Round(X42D), Round(Y42D)),
		//                               Point(Round(X43D), Round(Y43D)),
		//                               Point(Round(X44D), Round(Y44D)),
		//                               Point(Round(X41D), Round(Y41D))]);
		context.beginPath();
		context.moveTo(X41D, Y41D);
		context.lineTo(X42D, Y42D);
		context.lineTo(X43D, Y43D);
		context.lineTo(X44D, Y44D);
		context.lineTo(X41D, Y41D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//連結穴のブラシスタイルの指定
		var holeFillColor = "rgba(255, 255, 255, 0)";

	//通常の表示
	} else {
		//外形の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00888888;
		//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X5D), Round(Y5D)),
		//                               Point(Round(X6D), Round(Y6D)),
		//                               Point(Round(X7D), Round(Y7D)),
		//                               Point(Round(X8D), Round(Y8D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X5D, Y5D);
		context.lineTo(X6D, Y6D);
		context.lineTo(X7D, Y7D);
		context.lineTo(X8D, Y8D);
		context.lineTo(X1D, Y1D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		context.fillStyle = "rgb(136, 136, 136)";
		context.fill();

		//ピストンの描画(91 or 93)
		if (parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1Power") {
			//formMain.imgTemp.Canvas.Brush.Color := $00808FFF;
			//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
			context.fillStyle = "rgb(254, 128, 128)";		//254 ピストン部分の特殊色
		} else {
			//formMain.imgTemp.Canvas.Brush.Color := $00CCCCCC;
			//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
			context.fillStyle = "rgb(203, 204, 204)";		//203 ピストン部分の特殊色
		}
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X11D), Round(Y11D)),
		//                               Point(Round(X12D), Round(Y12D)),
		//                               Point(Round(X13D), Round(Y13D)),
		//                               Point(Round(X14D), Round(Y14D)),
		//                               Point(Round(X11D), Round(Y11D))]);
		context.beginPath();
		context.moveTo(X11D, Y11D);
		context.lineTo(X12D, Y12D);
		context.lineTo(X13D, Y13D);
		context.lineTo(X14D, Y14D);
		context.lineTo(X11D, Y11D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		context.fill();

		//ロッドの描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FF8080;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X21D), Round(Y21D)),
		//                               Point(Round(X22D), Round(Y22D)),
		//                               Point(Round(X23D), Round(Y23D)),
		//                               Point(Round(X24D), Round(Y24D)),
		//                               Point(Round(X21D), Round(Y21D))]);
		context.beginPath();
		context.moveTo(X21D, Y21D);
		context.lineTo(X22D, Y22D);
		context.lineTo(X23D, Y23D);
		context.lineTo(X24D, Y24D);
		context.lineTo(X21D, Y21D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
		context.fillStyle = "rgb(128, 128, 255)";
		context.fill();

		//ピストン固定ピンの描画
		//formMain.imgTemp.Canvas.Brush.Color := $00000000;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X31D), Round(Y31D)),
		//                               Point(Round(X32D), Round(Y32D)),
		//                               Point(Round(X33D), Round(Y33D)),
		//                               Point(Round(X34D), Round(Y34D)),
		//                               Point(Round(X31D), Round(Y31D))]);
		context.beginPath();
		context.moveTo(X31D, Y31D);
		context.lineTo(X32D, Y32D);
		context.lineTo(X33D, Y33D);
		context.lineTo(X34D, Y34D);
		context.lineTo(X31D, Y31D);
		context.fillStyle = "black";
		context.fill();
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X41D), Round(Y41D)),
		//                               Point(Round(X42D), Round(Y42D)),
		//                               Point(Round(X43D), Round(Y43D)),
		//                               Point(Round(X44D), Round(Y44D)),
		//                               Point(Round(X41D), Round(Y41D))]);
		context.beginPath();
		context.moveTo(X41D, Y41D);
		context.lineTo(X42D, Y42D);
		context.lineTo(X43D, Y43D);
		context.lineTo(X44D, Y44D);
		context.lineTo(X41D, Y41D);
		context.fillStyle = "black";
		context.fill();

		//パーツのidx取得用
		//外形の描画
		//PositionBitmap.Canvas.Brush.Color := no;
		//PositionBitmap.Canvas.Brush.Style := bsSolid;
		//PositionBitmap.Canvas.Pen.Color := no;
		//PositionBitmap.Canvas.Pen.Style := psSolid;
		//PositionBitmap.Canvas.Polygon([Point(Round(X8D), Round(Y8D)),
		//                             Point(Round(X1D), Round(Y1D)),
		//                             Point(Round(X6D), Round(Y6D)),
		//                             Point(Round(X7D), Round(Y7D)),
		//                             Point(Round(X8D), Round(Y8D))]);
		contextPos.beginPath();
		contextPos.moveTo(X1D, Y1D);
		contextPos.lineTo(X2D, Y2D);
		contextPos.lineTo(X3D, Y3D);
		contextPos.lineTo(X4D, Y4D);
		contextPos.lineTo(X5D, Y5D);
		contextPos.lineTo(X6D, Y6D);
		contextPos.lineTo(X7D, Y7D);
		contextPos.lineTo(X8D, Y8D);
		contextPos.lineTo(X1D, Y1D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//ピストンの描画
		//PositionBitmap.Canvas.Polygon([Point(Round(X11D), Round(Y11D)),
		//                             Point(Round(X12D), Round(Y12D)),
		//                             Point(Round(X13D), Round(Y13D)),
		//                             Point(Round(X14D), Round(Y14D)),
		//                             Point(Round(X11D), Round(Y11D))]);
		contextPos.beginPath();
		contextPos.moveTo(X11D, Y11D);
		contextPos.lineTo(X12D, Y12D);
		contextPos.lineTo(X13D, Y13D);
		contextPos.lineTo(X14D, Y14D);
		contextPos.lineTo(X11D, Y11D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();
		
		//ロッドの描画
		//PositionBitmap.Canvas.Polygon([Point(Round(X21D), Round(Y21D)),
		//                             Point(Round(X22D), Round(Y22D)),
		//                             Point(Round(X23D), Round(Y23D)),
		//                             Point(Round(X24D), Round(Y24D)),
		//                             Point(Round(X21D), Round(Y21D))]);
		contextPos.beginPath();
		contextPos.moveTo(X21D, Y21D);
		contextPos.lineTo(X22D, Y22D);
		contextPos.lineTo(X23D, Y23D);
		contextPos.lineTo(X24D, Y24D);
		contextPos.lineTo(X21D, Y21D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//連結穴のブラシスタイルの指定
		//formMain.imgTemp.Canvas.Brush.Color := clGray;
		var holeFillColor = "gray";
	}

	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	for (i = 0; i < 4; i++) {
		//(91 or 92)
		if (parts[idx].kind == "piston2Power" || parts[idx].kind == "piston2") {
			xD = Math.round(rotateX(x, y, x + i*20 + 240 + p, y, angle));
			yD = Math.round(rotateY(x, y, x + i*20 + 240 + p, y, angle));
			//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
			context.beginPath();
			context.arc(xD, yD, 5, 0, 2*Math.PI);
			context.fillStyle = holeFillColor;
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();

		} else {
			xD = Math.round(rotateX(x, y, x + i*20 + 60 + p, y, angle));
			yD = Math.round(rotateY(x, y, x + i*20 + 60 + p, y, angle));
			//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
			context.beginPath();
			context.arc(xD, yD, 5, 0, 2*Math.PI);
			context.fillStyle = holeFillColor;
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();
		}
	}

	//---------------------------------------------
	//ピンとペンの描画
	//---------------------------------------------
	addPin(idx);
	addPen(idx);
}

//----------------------------------------------------------
//  ロッド（含む、動力ロッド）の描画
//----------------------------------------------------------
function drawRod(idx) {
	var i, s;
	var X1, Y1, X2, Y2, x, y, r, angle;
	var X1D, Y1D, X2D, Y2D, X3D, Y3D, X4D, Y4D;
	var xD, yD;

	x = parts[idx].x;
	y = parts[idx].y;
	r = parts[idx].r;
	angle = parts[idx].a;
	X1 = x - 20;
	Y1 = y - 10;
	X2 = x + r - 20;
	Y2 = y + 10;

	X1D = Math.round(rotateX(x, y, X1, Y1, angle));
	Y1D = Math.round(rotateY(x, y, X1, Y1, angle));
	X2D = Math.round(rotateX(x, y, X2, Y1, angle));
	Y2D = Math.round(rotateY(x, y, X2, Y1, angle));
	X3D = Math.round(rotateX(x, y, X2, Y2, angle));
	Y3D = Math.round(rotateY(x, y, X2, Y2, angle));
	X4D = Math.round(rotateX(x, y, X1, Y2, angle));
	Y4D = Math.round(rotateY(x, y, X1, Y2, angle));

	//移動時の表示（輪郭のみ）
	if (parts[idx].transparent == true) {
		//formMain.imgTemp.Canvas.Brush.Color := $00FFFFFF;
		//formMain.imgTemp.Canvas.Brush.Style := bsClear;

		//動力の描画(15 or 16)
		if (parts[idx].kind == "rod2Power" || parts[idx].kind == "rod1Power") {
			//formMain.imgTemp.Canvas.Ellipse(Round(x-25), Round(y-25), Round(x+25), Round(y+25));
			context.beginPath();
			context.arc(x, y, 25, 0, 2*Math.PI);
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();
		}

		//輪郭の描画
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X1D, Y1D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//連結穴のブラシスタイルの指定
		var holeFillColor = "rgba(255, 255, 255, 0)";

	//通常の表示
	} else {
		//動力の描画(15 or 16)
		if (parts[idx].kind == "rod2Power" || parts[idx].kind == "rod1Power") {
			//formMain.imgTemp.Canvas.Brush.Color := $00808FFF;
			//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
			//formMain.imgTemp.Canvas.Ellipse(Round(x-25), Round(y-25), Round(x+25), Round(y+25));
			context.beginPath();
			context.arc(x, y, 25, 0, 2*Math.PI);
			context.fillStyle = "rgb(255, 128, 128)";
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();
		}
		
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FF8080;
		//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X1D, Y1D);
		context.fillStyle = "rgb(128, 128, 255)";
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//パーツのidx取得用
		//PositionBitmap.Canvas.Brush.Color := no;
		//PositionBitmap.Canvas.Brush.Style := bsSolid;
		//PositionBitmap.Canvas.Pen.Color := no;
		//PositionBitmap.Canvas.Pen.Style := psSolid;
		//if (Parts[no].ShapeType = 15) or (Parts[no].ShapeType = 16) then
		//PositionBitmap.Canvas.Ellipse(Round(x-25), Round(y-25), Round(x+25), Round(y+25));
		//PositionBitmap.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                             Point(Round(X2D), Round(Y2D)),
		//                             Point(Round(X3D), Round(Y3D)),
		//                             Point(Round(X4D), Round(Y4D)),
		//                             Point(Round(X1D), Round(Y1D))]);
		//15 or 16
		if (parts[idx].kind == "rod2Power" || parts[idx].kind == "rod1Power") {
			contextPos.beginPath();
			contextPos.arc(x, y, 25, 0, 2*Math.PI);
			contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
			contextPos.fill();
		}

		contextPos.beginPath();
		contextPos.moveTo(X1D, Y1D);
		contextPos.lineTo(X2D, Y2D);
		contextPos.lineTo(X3D, Y3D);
		contextPos.lineTo(X4D, Y4D);
		contextPos.lineTo(X1D, Y1D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//連結穴のブラシスタイルの指定
		//formMain.imgTemp.Canvas.Brush.Color := clGray;
		var holeFillColor = "gray";
	}

	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	//15 or 16
	if (parts[idx].kind == "rod2Power" || parts[idx].kind == "rod1Power") {
		s = 2;
	} else {
		s = 0;
	}
	
	for (i = s; i <= Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x + i*20, y, angle));
		yD = Math.round(rotateY(x, y, x + i*20, y, angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}

	//連結穴（原点）の描画
	xD = Math.round(rotateX(x, y, x + 0, y, angle));
	yD = Math.round(rotateY(x, y, x + 0, y, angle));
	//formMain.imgTemp.Canvas.MoveTo(Round(xD-1), Round(yD-1));
	//formMain.imgTemp.Canvas.LineTo(Round(xD+2), Round(yD+2));
	//formMain.imgTemp.Canvas.MoveTo(Round(xD+1), Round(yD-1));
	//formMain.imgTemp.Canvas.LineTo(Round(xD-2), Round(yD+2));
	context.beginPath();
	context.moveTo(xD-2, yD-2);
	context.lineTo(xD+2, yD+2);
	context.moveTo(xD+2, yD-2);
	context.lineTo(xD-2, yD+2);
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	//---------------------------------------------
	//ピンとペンの描画
	//---------------------------------------------
	addPin(idx);
	addPen(idx);
}

//----------------------------------------------------------
//  スライドロッドの描画
//----------------------------------------------------------
function drawRodSlide(idx) {
	var i;
	var x, y, r, angle;
	var rr;

	var X1,   X2,   X3,   X4,   X5,   X6,   X7,   X8,   X9;
	var X10,  X11,  X12,  X13,  X14,  X15,  X16,  X17,  X18;
	var Y1,   Y2,   Y3,   Y4,   Y5,   Y6,   Y7,   Y8,   Y9;
	var Y10,  Y11,  Y12,  Y13,  Y14,  Y15,  Y16,  Y17,  Y18;

	var X1D,  X2D,  X3D,  X4D,  X5D,  X6D,  X7D,  X8D,  X9D;
	var X10D, X11D, X12D, X13D, X14D, X15D, X16D, X17D, X18D;
	var Y1D,  Y2D,  Y3D,  Y4D,  Y5D,  Y6D,  Y7D,  Y8D,  Y9D;
	var Y10D, Y11D, Y12D, Y13D, Y14D, Y15D, Y16D, Y17D, Y18D;

	var xD, yD;
	var tc;

	x = parts[idx].x;
	y = parts[idx].y;
	rr = parts[idx].r;
	angle = parts[idx].a;
	//95
	if (parts[idx].kind == "rodSlide2") {
		r = 440;
	} else {
		r = 280;
	}

	X1 = x - 20;     Y1 = y - 10;
	X2 = x + r - 20; Y2 = y + 10;

	X1D = Math.round(rotateX(x, y, X1, Y1, angle));
	Y1D = Math.round(rotateY(x, y, X1, Y1, angle));
	X2D = Math.round(rotateX(x, y, X2, Y1, angle));
	Y2D = Math.round(rotateY(x, y, X2, Y1, angle));
	X3D = Math.round(rotateX(x, y, X2, Y2, angle));
	Y3D = Math.round(rotateY(x, y, X2, Y2, angle));
	X4D = Math.round(rotateX(x, y, X1, Y2, angle));
	Y4D = Math.round(rotateY(x, y, X1, Y2, angle));

	//移動時の表示（輪郭のみ）
	if (parts[idx].transparent == true) {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FFFFFF;
		//formMain.imgTemp.Canvas.Brush.Style := bsClear;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X1D, Y1D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//連結穴のブラシスタイルの指定
		var holeFillColor = "rgba(255, 255, 255, 0)";

	//通常の表示
	} else {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FF8080;
		//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X4D), Round(Y4D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X4D, Y4D);
		context.lineTo(X1D, Y1D);
		context.fillStyle = "rgb(128, 128, 255)";
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//パーツのidx取得用
		//PositionBitmap.Canvas.Brush.Color := no;
		//PositionBitmap.Canvas.Brush.Style := bsSolid;
		//PositionBitmap.Canvas.Pen.Color := no;
		//PositionBitmap.Canvas.Pen.Style := psSolid;
		//PositionBitmap.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                             Point(Round(X2D), Round(Y2D)),
		//                             Point(Round(X3D), Round(Y3D)),
		//                             Point(Round(X4D), Round(Y4D)),
		//                             Point(Round(X1D), Round(Y1D))]);
		contextPos.beginPath();
		contextPos.moveTo(X1D, Y1D);
		contextPos.lineTo(X2D, Y2D);
		contextPos.lineTo(X3D, Y3D);
		contextPos.lineTo(X4D, Y4D);
		contextPos.lineTo(X1D, Y1D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//連結穴のブラシスタイルの指定
		//formMain.imgTemp.Canvas.Brush.Color := clGray;
		var holeFillColor = "gray";
	}

	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	for (i = 0; i <= Math.round((r-40) / 20); i++) {
		if (i < 3 || i > Math.round((r-40) / 20) - 3) {
			xD = Math.round(rotateX(x, y, x + i*20, y, angle));
			yD = Math.round(rotateY(x, y, x + i*20, y, angle));
			//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
			context.beginPath();
			context.arc(xD, yD, 5, 0, 2*Math.PI);
			context.fillStyle = holeFillColor;
			context.fill();
			context.strokeStyle = "black";
			context.lineWidth = 1;
			context.stroke();
		}
	}

	X1  = x -     20 + 80 + 0.00;        Y1  = y - 5.00;
	X2  = x + r - 20 - 80 + 0.00;        Y2  = y - 5.00;
	X3  = x + r - 20 - 80 + 1.91;        Y3  = y - 4.62;
	X4  = x + r - 20 - 80 + 3.54;        Y4  = y - 3.54;
	X5  = x + r - 20 - 80 + 5.62;        Y5  = y - 1.91;
	X6  = x + r - 20 - 80 + 6.00;        Y6  = y - 0.00;
	X7  = x + r - 20 - 80 + 5.62;        Y7  = y + 1.91;
	X8  = x + r - 20 - 80 + 3.54;        Y8  = y + 3.54;
	X9  = x + r - 20 - 80 + 1.91;        Y9  = y + 4.62;
	X10 = x + r - 20 - 80 + 0.00;        Y10 = y + 5.00;
	X11 = x -     20 + 80 + 0.00;        Y11 = y + 5.00;
	X12 = x -     20 + 80 - 1.91;        Y12 = y + 4.62;
	X13 = x -     20 + 80 - 3.54;        Y13 = y + 3.54;
	X14 = x -     20 + 80 - 5.62;        Y14 = y + 1.91;
	X15 = x -     20 + 80 - 6.00;        Y15 = y + 0.00;
	X16 = x -     20 + 80 - 5.62;        Y16 = y - 1.91;
	X17 = x -     20 + 80 - 3.54;        Y17 = y - 3.54;
	X18 = x -     20 + 80 - 1.91;        Y18 = y - 4.62;

	X1D  = Math.round(rotateX(x, y, X1,  Y1,  angle)); Y1D  = Math.round(rotateY(x, y, X1,  Y1,  angle));
	X2D  = Math.round(rotateX(x, y, X2,  Y2,  angle)); Y2D  = Math.round(rotateY(x, y, X2,  Y2,  angle));
	X3D  = Math.round(rotateX(x, y, X3,  Y3,  angle)); Y3D  = Math.round(rotateY(x, y, X3,  Y3,  angle));
	X4D  = Math.round(rotateX(x, y, X4,  Y4,  angle)); Y4D  = Math.round(rotateY(x, y, X4,  Y4,  angle));
	X5D  = Math.round(rotateX(x, y, X5,  Y5,  angle)); Y5D  = Math.round(rotateY(x, y, X5,  Y5,  angle));
	X6D  = Math.round(rotateX(x, y, X6,  Y6,  angle)); Y6D  = Math.round(rotateY(x, y, X6,  Y6,  angle));
	X7D  = Math.round(rotateX(x, y, X7,  Y7,  angle)); Y7D  = Math.round(rotateY(x, y, X7,  Y7,  angle));
	X8D  = Math.round(rotateX(x, y, X8,  Y8,  angle)); Y8D  = Math.round(rotateY(x, y, X8,  Y8,  angle));
	X9D  = Math.round(rotateX(x, y, X9,  Y9,  angle)); Y9D  = Math.round(rotateY(x, y, X9,  Y9,  angle));
	X10D = Math.round(rotateX(x, y, X10, Y10, angle)); Y10D = Math.round(rotateY(x, y, X10, Y10, angle));
	X11D = Math.round(rotateX(x, y, X11, Y11, angle)); Y11D = Math.round(rotateY(x, y, X11, Y11, angle));
	X12D = Math.round(rotateX(x, y, X12, Y12, angle)); Y12D = Math.round(rotateY(x, y, X12, Y12, angle));
	X13D = Math.round(rotateX(x, y, X13, Y13, angle)); Y13D = Math.round(rotateY(x, y, X13, Y13, angle));
	X14D = Math.round(rotateX(x, y, X14, Y14, angle)); Y14D = Math.round(rotateY(x, y, X14, Y14, angle));
	X15D = Math.round(rotateX(x, y, X15, Y15, angle)); Y15D = Math.round(rotateY(x, y, X15, Y15, angle));
	X16D = Math.round(rotateX(x, y, X16, Y16, angle)); Y16D = Math.round(rotateY(x, y, X16, Y16, angle));
	X17D = Math.round(rotateX(x, y, X17, Y17, angle)); Y17D = Math.round(rotateY(x, y, X17, Y17, angle));
	X18D = Math.round(rotateX(x, y, X18, Y18, angle)); Y18D = Math.round(rotateY(x, y, X18, Y18, angle));

	//スライドエリアの描画
	//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D),  Round(Y1D)),
	//                               Point(Round(X2D),  Round(Y2D)),
	//                               Point(Round(X3D),  Round(Y3D)),
	//                               Point(Round(X4D),  Round(Y4D)),
	//                               Point(Round(X5D),  Round(Y5D)),
	//                               Point(Round(X6D),  Round(Y6D)),
	//                               Point(Round(X7D),  Round(Y7D)),
	//                               Point(Round(X8D),  Round(Y8D)),
	//                               Point(Round(X9D),  Round(Y9D)),
	//                               Point(Round(X10D), Round(Y10D)),
	//                               Point(Round(X11D), Round(Y11D)),
	//                               Point(Round(X12D), Round(Y12D)),
	//                               Point(Round(X13D), Round(Y13D)),
	//                               Point(Round(X14D), Round(Y14D)),
	//                               Point(Round(X15D), Round(Y15D)),
	//                               Point(Round(X16D), Round(Y16D)),
	//                               Point(Round(X17D), Round(Y17D)),
	//                               Point(Round(X18D), Round(Y18D)),
	//                               Point(Round(X1D),  Round(Y1D))]);
	context.beginPath();
	context.moveTo(X1D,  Y1D);
	context.lineTo(X2D,  Y2D);
	context.lineTo(X3D,  Y3D);
	context.lineTo(X4D,  Y4D);
	context.lineTo(X5D,  Y5D);
	context.lineTo(X6D,  Y6D);
	context.lineTo(X7D,  Y7D);
	context.lineTo(X8D,  Y8D);
	context.lineTo(X9D,  Y9D);
	context.lineTo(X10D, Y10D);
	context.lineTo(X11D, Y11D);
	context.lineTo(X12D, Y12D);
	context.lineTo(X13D, Y13D);
	context.lineTo(X14D, Y14D);
	context.lineTo(X15D, Y15D);
	context.lineTo(X16D, Y16D);
	context.lineTo(X17D, Y17D);
	context.lineTo(X18D, Y18D);
	context.lineTo(X1D,  Y1D);
	context.fillStyle = holeFillColor;
	context.fill();
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	//スライド基点のピン
	xD = Math.round(rotateX(x, y, x + rr, y, angle));
	yD = Math.round(rotateY(x, y, x + rr, y, angle));
	if (holeFillColor == "gray") {
		//formMain.imgTemp.Canvas.Brush.Color := $00101010;
		//formMain.imgTemp.Canvas.Pen.Color := $00101010;
		context.fillStyle = "rgb(17, 17, 17)";		//移動のための特別な色
	}
	//formMain.imgTemp.Canvas.Ellipse(Round(xD-14), Round(yD-14), Round(xD+15), Round(yD+15));
	context.beginPath();
	context.arc(xD, yD, 14, 0, 2*Math.PI);
	context.fill();
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	if (holeFillColor == "gray") {
		//formMain.imgTemp.Canvas.Brush.Color := $00C0C0C0;
		context.fillStyle = "rgb(193, 193, 193)";		//移動のための特別な色
	}
	//formMain.imgTemp.Canvas.Ellipse(Round(xD-9), Round(yD-9), Round(xD+10), Round(yD+10));
	context.beginPath();
	context.arc(xD, yD, 9, 0, 2*Math.PI);
	context.fill();
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	if (holeFillColor == "gray") {
		//formMain.imgTemp.Canvas.Brush.Color := $00101010;
		context.fillStyle = "rgb(17, 17, 17)";		//移動のための特別な色
	}
	//formMain.imgTemp.Canvas.Ellipse(Round(xD-4), Round(yD-4), Round(xD+5), Round(yD+5));
	context.beginPath();
	context.arc(xD, yD, 4, 0, 2*Math.PI);
	context.fill();
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	//連結穴（原点）の描画
	xD = Math.round(rotateX(x, y, x + 0, y, angle));
	yD = Math.round(rotateY(x, y, x + 0, y, angle));
	//formMain.imgTemp.Canvas.Pen.Color := clBlack;
	//formMain.imgTemp.Canvas.MoveTo(Round(xD-1), Round(yD-1));
	//formMain.imgTemp.Canvas.LineTo(Round(xD+2), Round(yD+2));
	//formMain.imgTemp.Canvas.MoveTo(Round(xD+1), Round(yD-1));
	//formMain.imgTemp.Canvas.LineTo(Round(xD-2), Round(yD+2));
	context.beginPath();
	context.moveTo(xD-2, yD-2);
	context.lineTo(xD+2, yD+2);
	context.moveTo(xD+2, yD-2);
	context.lineTo(xD-2, yD+2);
	context.strokeStyle = "black";
	context.lineWidth = 1;
	context.stroke();

	//---------------------------------------------
	//ピンとペンの描画
	//---------------------------------------------
	addPin(idx);
	addPen(idx);
}

//----------------------------------------------------------
//  三角形の描画
//----------------------------------------------------------
function drawTriangle(idx) {
	var i;
	var x, y, r, angle;
	var X1D, Y1D, X2D, Y2D, X3D, Y3D;
	var xD, yD;

	x = parts[idx].x;
	y = parts[idx].y;
	r = parts[idx].r;
	angle = parts[idx].a;

	X1D = Math.round(rotateX(x, y, x-10,   y+10,   angle));
	Y1D = Math.round(rotateY(x, y, x-10,   y+10,   angle));
	X2D = Math.round(rotateX(x, y, x+r-10, y+10,   angle));
	Y2D = Math.round(rotateY(x, y, x+r-10, y+10,   angle));
	X3D = Math.round(rotateX(x, y, x-10,   y-r+10, angle));
	Y3D = Math.round(rotateY(x, y, x-10,   y-r+10, angle));

	//移動時の表示（輪郭のみ）
	if (parts[idx].transparent == true) {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FFFFFF;
		//formMain.imgTemp.Canvas.Brush.Style := bsClear;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X1D, Y1D);
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//連結穴のブラシスタイルの指定
		var holeFillColor = "rgba(255, 255, 255, 0)";

	//通常の表示
	} else {
		//輪郭の描画
		//formMain.imgTemp.Canvas.Brush.Color := $00FF8080;
		//formMain.imgTemp.Canvas.Brush.Style := bsSolid;
		//formMain.imgTemp.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                               Point(Round(X2D), Round(Y2D)),
		//                               Point(Round(X3D), Round(Y3D)),
		//                               Point(Round(X1D), Round(Y1D))]);
		context.beginPath();
		context.moveTo(X1D, Y1D);
		context.lineTo(X2D, Y2D);
		context.lineTo(X3D, Y3D);
		context.lineTo(X1D, Y1D);
		context.fillStyle = "rgb(128, 128, 255)";
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();

		//パーツのidx取得用
		//PositionBitmap.Canvas.Brush.Color := no;
		//PositionBitmap.Canvas.Brush.Style := bsSolid;
		//PositionBitmap.Canvas.Pen.Color := no;
		//PositionBitmap.Canvas.Pen.Style := psSolid;
		//PositionBitmap.Canvas.Polygon([Point(Round(X1D), Round(Y1D)),
		//                             Point(Round(X2D), Round(Y2D)),
		//                             Point(Round(X3D), Round(Y3D)),
		//                             Point(Round(X1D), Round(Y1D))]);
		contextPos.beginPath();
		contextPos.moveTo(X1D, Y1D);
		contextPos.lineTo(X2D, Y2D);
		contextPos.lineTo(X3D, Y3D);
		contextPos.lineTo(X1D, Y1D);
		contextPos.fillStyle = "rgb(" + idx + ", " + idx + ", " + idx + ")";
		contextPos.fill();

		//連結穴のブラシスタイルの指定
		//formMain.imgTemp.Canvas.Brush.Color := clGray;
		var holeFillColor = "gray";
	}

	//---------------------------------------------
	//連結穴の描画
	//---------------------------------------------
	//縦線
	for (i = 0; i < Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x, y-(i*20), angle));
		yD = Math.round(rotateY(x, y, x, y-(i*20), angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}
	//横線
	for (i = 1; i <= Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x+(i*20), y, angle));
		yD = Math.round(rotateY(x, y, x+(i*20), y, angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}
	//斜め線
	for (i = 0; i <= Math.round((r-40) / 20); i++) {
		xD = Math.round(rotateX(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle));
		yD = Math.round(rotateY(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle));
		//formMain.imgTemp.Canvas.Ellipse(Round(xD-5), Round(yD-5), Round(xD+6), Round(yD+6));
		context.beginPath();
		context.arc(xD, yD, 5, 0, 2*Math.PI);
		context.fillStyle = holeFillColor;
		context.fill();
		context.strokeStyle = "black";
		context.lineWidth = 1;
		context.stroke();
	}

	//---------------------------------------------
	//ピンとペンの描画
	//---------------------------------------------
	addPin(idx);
	addPen(idx);
}

//----------------------------------------------------------
//  部品にピンをセットする
//----------------------------------------------------------
function SetPin(PinType, xs, ys) {
	var idx;
	var i;
	var x, y, r, angle;
	var xD, yD;

	var rt;
	var p;

	rt = 0;

	for (idx = 0; idx < partsCount; idx++) {
		x = parts[idx].x;
		y = parts[idx].y;
		r = parts[idx].r;
		angle = parts[idx].a;

		//円盤（11, 12, 13, 21, 22, 23）
		if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk3Power" || parts[idx].kind == "disk1" || parts[idx].kind == "disk2" || parts[idx].kind == "disk3") {
			//円盤に固定ピンは配置しない
			if (PinType == 0) {
				for (i = 0; i <= Math.round((r-40) / 20); i++) {
					xD = rotateX(x, y, x, y-(i*20+30), angle);
					yD = rotateY(x, y, x, y-(i*20+30), angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0;
						parts[idx].pinY[parts[idx].pinCount] = 0-(i*20+30);
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}

					xD = rotateX(x, y, x, y+(i*20+30), angle);
					yD = rotateY(x, y, x, y+(i*20+30), angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0;
						parts[idx].pinY[parts[idx].pinCount] = 0+(i*20+30);
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}

					xD = rotateX(x, y, x-(i*20+20), y, angle);
					yD = rotateY(x, y, x-(i*20+20), y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0-(i*20+20);
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}

					xD = rotateX(x, y, x+(i*20+20), y, angle);
					yD = rotateY(x, y, x+(i*20+20), y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0+(i*20+20);
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}
				}
			}
		}
		
		//動力ロッド(15, 16)
		else if (parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") {
			//動力ロッドに固定ピンは配置しない
			if (PinType == 0) {
				for (i = 2; i <= Math.round((r-40) / 20); i++) {
					xD = rotateX(x, y, x + i*20, y, angle);
					yD = rotateY(x, y, x + i*20, y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0 + i*20;
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}
				}
			}
		}

		//長いピストン(91, 93)
		else if (parts[idx].kind == "piston2Power" || parts[idx].kind == "piston2") {
			//動力ピストンに固定ピンは配置しない
			if (PinType == 0) {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}

				for (i = 0; i <= 3; i++) {
					xD = rotateX(x, y, x + i*20 + 240 + p, y, angle);
					yD = rotateY(x, y, x + i*20 + 240 + p, y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0 + i*20 + 240;
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}
				}
			}
		}

		//短いピストン(92, 94)
		else if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston1") {
			//動力ピストンに固定ピンは配置しない
			if (PinType == 0) {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}

				for (i = 0; i <= 3; i++) {
					xD = rotateX(x, y, x + i*20 + 60 + p, y, angle);
					yD = rotateY(x, y, x + i*20 + 60 + p, y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0 + i*20 + 60;
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}
				}
			}
		}

		//ロッド(31, 32, 33, 34)
		else if (parts[idx].kind == "rod1" || parts[idx].kind == "rod2" || parts[idx].kind == "rod3" || parts[idx].kind == "rod4" || parts[idx].kind == "rod5" || parts[idx].kind == "rod6") {
			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x + i*20, y, angle);
				yD = rotateY(x, y, x + i*20, y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
					parts[idx].pinType[parts[idx].pinCount] = PinType;
					parts[idx].pinX[parts[idx].pinCount] = 0 + i*20;
					parts[idx].pinY[parts[idx].pinCount] = 0;
					parts[idx].pinCount = parts[idx].pinCount + 1;
					rt = 1;
				}
			}
		}

		//スライドロッド(95, 96)
		else if (parts[idx].kind == "rodSlide1" || parts[idx].kind == "rodSlide2") {
			if (parts[idx].kind == "rodSlide2") {
				r = 440;
			} else {
				r = 280;
			}

			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				if (i < 3 || i > Math.round((r-40) / 20) - 3) {
					xD = rotateX(x, y, x + i*20, y, angle);
					yD = rotateY(x, y, x + i*20, y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
						parts[idx].pinType[parts[idx].pinCount] = PinType;
						parts[idx].pinX[parts[idx].pinCount] = 0 + i*20;
						parts[idx].pinY[parts[idx].pinCount] = 0;
						parts[idx].pinCount = parts[idx].pinCount + 1;
						rt = 1;
					}
				}
			}
		}

		//三角(41, 42)
		else if (parts[idx].kind == "triangle1" || parts[idx].kind == "triangle2") {
			for (i = 0; i < Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x, y-(i*20), angle);
				yD = rotateY(x, y, x, y-(i*20), angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
					parts[idx].pinType[parts[idx].pinCount] = PinType;
					parts[idx].pinX[parts[idx].pinCount] = 0;
					parts[idx].pinY[parts[idx].pinCount] = 0-(i*20);
					parts[idx].pinCount = parts[idx].pinCount + 1;
					rt = 1;
				}
			}

			for (i = 1; i < Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x+(i*20), y, angle);
				yD = rotateY(x, y, x+(i*20), y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
					parts[idx].pinType[parts[idx].pinCount] = PinType;
					parts[idx].pinX[parts[idx].pinCount] = 0+(i*20);
					parts[idx].pinY[parts[idx].pinCount] = 0;
					parts[idx].pinCount = parts[idx].pinCount + 1;
					rt = 1;
				}
			}

            for (i = 0; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle);
				yD = rotateY(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].pinIndex[parts[idx].pinCount] = intPinIndex;
					parts[idx].pinType[parts[idx].pinCount] = PinType;
					parts[idx].pinX[parts[idx].pinCount] = 0+(i*20);
					parts[idx].pinY[parts[idx].pinCount] = 0-(Math.round((r-40) / 20)-i)*20;
					parts[idx].pinCount = parts[idx].pinCount + 1;
					rt = 1;
				}
			}
		}
	}

	if (rt == 1) {
		intPinIndex++;
	}

	return rt;
}

//----------------------------------------------------------
//  部品にペンをセットする
//----------------------------------------------------------
function SetPen(PenType, xs, ys) {
	var idx;
	var i;
	var x, y, r, angle;
	var xD, yD;

	var rt;
	var p;

	rt = 0;

	for (idx = 0; idx < partsCount; idx++) {

		x = parts[idx].x;
		y = parts[idx].y
		r = parts[idx].r;
		angle = parts[idx].a;

        //円盤
		if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk3Power" || parts[idx].kind == "disk1" || parts[idx].kind == "disk2" || parts[idx].kind == "disk3") {
			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x, y-(i*20+30), angle);
				yD = rotateY(x, y, x, y-(i*20+30), angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0;
					parts[idx].penY[parts[idx].penCount] = 0-(i*20+30);
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}

				xD = rotateX(x, y, x, y+(i*20+30), angle);
				yD = rotateY(x, y, x, y+(i*20+30), angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0;
					parts[idx].penY[parts[idx].penCount] = 0+(i*20+30);
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}

				xD = rotateX(x, y, x-(i*20+20), y, angle);
				yD = rotateY(x, y, x-(i*20+20), y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					partidxs[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0-(i*20+20);
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}

				xD = rotateX(x, y, x+(i*20+20), y, angle);
				yD = rotateY(x, y, x+(i*20+20), y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0+(i*20+20);
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}

		//動力ロッド(15, 16)
		else if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk3Power" || parts[idx].kind == "disk1" || parts[idx].kind == "disk2" || parts[idx].kind == "disk3") {
			for (i = 2; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x + i*20, y, angle);
				yD = rotateY(x, y, x + i*20, y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0 + i*20;
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}

		//動力ピストン(91, 92)
		else if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power") {
			while (r > 360) {
				r = r - 360;
			}
			while (r < 0) {
				r = r + 360;
			}
			if (r > 180) {
				p = 360 - r;
			} else {
				p = r;
			}

			for (i = 0; i <= 3; i++) {
				xD = rotateX(x, y, x + i*20 + 240 + p, y, angle);
				yD = rotateY(x, y, x + i*20 + 240 + p, y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0 + i*20 + 240;
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}

		//ピストン(93, 94)
		else if (parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
			while (r > 360) {
				r = r - 360;
			}
			while (r < 0) {
				r = r + 360;
			}
			if (r > 180) {
				p = 360 - r;
			} else {
				p = r;
			}

			for (i = 0; i <= 3; i++) {
				xD = rotateX(x, y, x + i*20 + 60 + p, y, angle);
				yD = rotateY(x, y, x + i*20 + 60 + p, y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0 + i*20 + 60;
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}

		//ロッド(31, 32, 33, 34)
		else if (parts[idx].kind == "rod1" || parts[idx].kind == "rod2" || parts[idx].kind == "rod3" || parts[idx].kind == "rod4" || parts[idx].kind == "rod5" || parts[idx].kind == "rod6") {
			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x + i*20, y, angle);
				yD = rotateY(x, y, x + i*20, y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0 + i*20;
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}

		//スライドロッド(95, 96)
		else if (parts[idx].kind == "rodSlide1" || parts[idx].kind == "rodSlide2") {
			if (parts[idx].kind == "rodSlide2") {
				r = 440;
			} else {
				r = 280;
			}
			
			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				if (i < 3 || i > Math.round((r-40) / 20) - 3) {
					xD = rotateX(x, y, x + i*20, y, angle);
					yD = rotateY(x, y, x + i*20, y, angle);
					if (CmpPosition(xD, yD, xs, ys) == true) {
						parts[idx].penType[parts[idx].penCount] = PenType;
						parts[idx].penX[parts[idx].penCount] = 0 + i*20;
						parts[idx].penY[parts[idx].penCount] = 0;
						parts[idx].penCount = parts[idx].penCount + 1;
						rt = 1;
					}
				}
			}
		}

		//三角(41, 42)
		else if (parts[idx].kind == "triangle1" || parts[idx].kind == "triangle2") {
			for (i = 0; i < Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x, y-(i*20), angle);
				yD = rotateY(x, y, x, y-(i*20), angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0;
					parts[idx].penY[parts[idx].penCount] = 0-(i*20);
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}

			for (i = 1; i < Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x+(i*20), y, angle);
				yD = rotateY(x, y, x+(i*20), y, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0+(i*20);
					parts[idx].penY[parts[idx].penCount] = 0;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}

			for (i = 0; i <= Math.round((r-40) / 20); i++) {
				xD = rotateX(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle);
				yD = rotateY(x, y, x+(i*20), y-(Math.round((r-40) / 20)-i)*20, angle);
				if (CmpPosition(xD, yD, xs, ys) == true) {
					parts[idx].penType[parts[idx].penCount] = PenType;
					parts[idx].penX[parts[idx].penCount] = 0+(i*20);
					parts[idx].penY[parts[idx].penCount] = 0-(Math.round((r-40) / 20)-i)*20;
					parts[idx].penCount = parts[idx].penCount + 1;
					rt = 1;
				}
			}
		}
	}
	return  rt;
}

//----------------------------------------------------------
//  部品の回転
//    ピンが無い場合は、原点中心に
//    ピンが１つの場合は、ピンを中心に
//    ピンが２つ以上の場合は、回転しない
//----------------------------------------------------------
function RotateParts(idx, angle) {
	var xD1, yD1;
	var xD2, yD2;
	var x, y, a;
	var r, p;

	//ピンが無い場合は、基準点を中心に回転
	if (parts[idx].pinCount == 0) {
		if (angle == 0) {
			parts[idx].a = 0;
		} else {
			parts[idx].a = parts[idx].a + angle;
		}
	}

	//ピンが１つの場合は、そのピンを中心に回転
	else if (parts[idx].pinCount == 1) {
		if (angle == 1000) {
			x = parts[idx].x;
			y = parts[idx].y;
			a = parts[idx].a;
			r = parts[idx].r;

			if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}
			} else {
				p = 0;
			}

			//現在のピン（回転の中心となる）の座標
			xD1 = rotateX(x, y, x+parts[idx].pinX[0]+p, y+parts[idx].pinY[0], a);
			yD1 = rotateY(x, y, x+parts[idx].pinX[0]+p, y+parts[idx].pinY[0], a);
			xD2 = rotateX(xD1, yD1, parts[idx].x, parts[idx].y, -a);
			yD2 = rotateY(xD1, yD1, parts[idx].x, parts[idx].y, -a);
			parts[idx].x = xD2;
			parts[idx].y = yD2;
			parts[idx].a = 0;

		} else {
			x = parts[idx].x;
			y = parts[idx].y;
			a = parts[idx].a;
			r = parts[idx].r;

			if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}
			} else {
				p = 0;
			}

			//現在のピン（回転の中心となる）の座標
			xD1 = rotateX(x, y, x+parts[idx].pinX[0]+p, y+parts[idx].pinY[0], a);
			yD1 = rotateY(x, y, x+parts[idx].pinX[0]+p, y+parts[idx].pinY[0], a);
			xD2 = rotateX(xD1, yD1, parts[idx].x, parts[idx].y, angle);
			yD2 = rotateY(xD1, yD1, parts[idx].x, parts[idx].y, angle);
			parts[idx].x = xD2;
			parts[idx].y = yD2;
			parts[idx].a = a + angle;
		}
	}

	AdjustAngle(idx);
}

//----------------------------------------------------------
//  指定位置のピンのタイプを変更する
//----------------------------------------------------------
function ChangePinType(xs, ys, PinType) {
	var idx, i;
	var x, y, angle;
	var xD, yD;
	var r, p;

	for (idx = 0; idx < partsCount; idx++) {
		x = parts[idx].x;
		y = parts[idx].y;
		angle = parts[idx].a;
		r = parts[idx].r;

		if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
			while (r > 360) {
				r = r - 360;
			}
			while (r < 0) {
				r = r + 360;
			}
			if (r > 180) {
				p = 360 - r;
			} else {
				p = r;
			}
		} else {
			p = 0;
		}

		for (i = 0; i < parts[idx].pinCount; i++) {
			xD = rotateX(x, y, x+parts[idx].pinX[i]+p, y+parts[idx].pinY[i], angle);
			yD = rotateY(x, y, x+parts[idx].pinX[i]+p, y+parts[idx].pinY[i], angle);

			if (CmpPosition(xD, yD, xs, ys) == true) {
				parts[idx].pinType[i] = PinType;
			}
		}
	}
}

//----------------------------------------------------------
//  指定Indexのピンのタイプを変更する
//----------------------------------------------------------
function ChangePinType2(PinIndex, PinType) {
	var idx, i;

	for (idx = 0; idx < partsCount; idx++) {
		for (i = 0; i < parts[idx].pinCount; i++) {
			if (parts[idx].pinIndex[i] == PinIndex) {
				parts[idx].pinType[i] = PinType;
			}
		}
	}
}


