﻿//==========================================================
//	linksim-edit.js by LinkSim for Web
//==========================================================
//##########################################################
//	パーツの配置・削除
//##########################################################
//----------------------------------------------------------
//	クリック位置にパーツを配置
//----------------------------------------------------------
function addParts(kind, x, y, ctrl) {
	//パーツ上限に達している
	if (partsCount >= MaxParts) {
		MyMessageDlg(0, langConv("警告"), langConv("これ以上の部品は配置できません。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	//動力パーツの有無（複数の動力パーツは配置できない）
	else if (powerFlag == true && (kind == "disk3Power" || kind == "disk2Power" || kind == "disk1Power" || kind == "piston2Power" || kind == "piston1Power" || kind == "rod2Power" || kind == "rod1Power")) {
		MyMessageDlg(0, langConv("警告"), langConv("複数の動力パーツは配置できません。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	//黒色ペンの有無（同色の複数のペンは配置できない）
	else if (penBlackFlag == true && kind == "pencilBlack") {
		MyMessageDlg(0, langConv("警告"), langConv("黒色ペンは既に配置されています。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	//青色ペンの有無（同色の複数のペンは配置できない）
	else if (penBlueFlag == true && kind == "pencilBlue") {
		MyMessageDlg(0, langConv("警告"), langConv("青色ペンは既に配置されています。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	//赤色ペンの有無（同色の複数のペンは配置できない）
	else if (penRedFlag == true && kind == "pencilRed") {
		MyMessageDlg(0, langConv("警告"), langConv("赤色ペンは既に配置されています。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	//緑色ペンの有無（同色の複数のペンは配置できない）
	else if (penGreenFlag == true && kind == "pencilGreen") {
		MyMessageDlg(0, langConv("警告"), langConv("緑色ペンは既に配置されています。"), null)
		document.getElementById("edit").checked = true;
		selectToolKind = "edit";
	}
	
	else {
		//ツールが「disk3Power」の場合
		if (kind == "disk3Power") {
			parts[partsCount] = new part(partsCount, "disk3Power", FitGrid(x), FitGrid(y));
		    parts[partsCount].r = 120;
		    parts[partsCount].pinCount = 1;
		    parts[partsCount].pinIndex[0] = partsCount;
		    parts[partsCount].pinType[0] = 1;	//1=固定
		    parts[partsCount].pinX[0] = 0;
		    parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「disk2Power」の場合
		else if (kind == "disk2Power") {
			parts[partsCount] = new part(partsCount, "disk2Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 100;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;	//1=固定
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「disk1Power」の場合
		else if (kind == "disk1Power") {
			parts[partsCount] = new part(partsCount, "disk1Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 80;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;	//1=固定
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「disk3」の場合
		else if (kind == "disk3") {
			parts[partsCount] = new part(partsCount, "disk3", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 120;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;	//1=固定
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「disk2」の場合
		else if (kind == "disk2") {
			parts[partsCount] = new part(partsCount, "disk2", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 100;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;	//1=固定
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「disk1」の場合
		else if (kind == "disk1") {
			parts[partsCount] = new part(partsCount, "disk1", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 80;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;	//1=固定
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawDisk(partsCount);		//linksim-draw.js
			partsCount++;
		}
		
		//ツールが「piston2Power」の場合
		else if (kind == "piston2Power") {
			parts[partsCount] = new part(partsCount, "piston2Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 90;
			
			//drawPiston(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「piston1Power」の場合
		else if (kind == "piston1Power") {
			parts[partsCount] = new part(partsCount, "piston1Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 90;
			
			//drawPiston(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「piston2」の場合
		else if (kind == "piston2") {
			parts[partsCount] = new part(partsCount, "piston2", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 90;
			
			//drawPiston(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「piston1」の場合
		else if (kind == "piston1") {
			parts[partsCount] = new part(partsCount, "piston1", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 90;
			
			//drawPiston(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rod2Power」の場合
		else if (kind == "rod2Power") {
			parts[partsCount] = new part(partsCount, "rod2Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 200;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawRod(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「rod1Power」の場合
		else if (kind == "rod1Power") {
			parts[partsCount] = new part(partsCount, "rod1Power", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 120;
	        parts[partsCount].pinCount = 1;
	        parts[partsCount].pinIndex[0] = partsCount;
	        parts[partsCount].pinType[0] = 1;
	        parts[partsCount].pinX[0] = 0;
	        parts[partsCount].pinY[0] = 0;
			
			//drawRod(partsCount);		//linksim-draw.js
			powerPartsIndex = partsCount;
			partsCount++;
			powerFlag = true;
			document.getElementById("trackBar").value = 360;
		}
		//ツールが「rod4」の場合
		else if (kind == "rod4") {
			parts[partsCount] = new part(partsCount, "rod4", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 440;
			
			//drawRod(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rod3」の場合
		else if (kind == "rod3") {
			parts[partsCount] = new part(partsCount, "rod3", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 360;
			
			//drawRod(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rod2」の場合
		else if (kind == "rod2") {
			parts[partsCount] = new part(partsCount, "rod2", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 280;
			
			//drawRod(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rod1」の場合
		else if (kind == "rod1") {
			parts[partsCount] = new part(partsCount, "rod1", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 200;
			
			//drawRod(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rodSlide2」の場合
		else if (kind == "rodSlide2") {
			parts[partsCount] = new part(partsCount, "rodSlide2", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 200;
			
			//drawRodSlide(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「rodSlide1」の場合
		else if (kind == "rodSlide1") {
			parts[partsCount] = new part(partsCount, "rodSlide1", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 120;
			
			//drawRodSlide(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「triangle2」の場合
		else if (kind == "triangle2") {
			parts[partsCount] = new part(partsCount, "triangle2", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 200;
			
			//drawTriangle(partsCount);		//linksim-draw.js
			partsCount++;
		}
		//ツールが「triangle1」の場合
		else if (kind == "triangle1") {
			parts[partsCount] = new part(partsCount, "triangle1", FitGrid(x), FitGrid(y));
	        parts[partsCount].r = 160;
			
			//drawTriangle(partsCount);		//linksim-draw.js
			partsCount++;
		}
		
		//ツールが「pinMove(61)」の場合
		else if (kind == "pinMove") {
			//直近（5px以内）の接続穴の座標とParts[]Indexを取得（無い場合は、Parts[]Index=-1が返る）
			var tmpPos = new GetNearHoleByAllParts(x, y);
			//直近に接続穴あり
			if (tmpPos.idx != -1) {
				if (IsPin(tmpPos.x, tmpPos.y) == -1) {
					//接続パーツ数の取得
					var cntParts = CountHole(tmpPos.x, tmpPos.y);

					//２個のパーツがあるか否かのチェック
					if (cntParts >= 2) {
						//パーツへの可動ピンのセット
						SetPin(0, tmpPos.x, tmpPos.y);

					//３個以上のパーツがある
					//} else if (cntParts > 2) {
					//	MyMessageDlg(0, "警告", "３つ以上の部品を接続することはできません。", null)
					//	document.getElementById("edit").checked = true;
					//	selectToolKind = "edit";

					//１個のパーツ
					} else if (cntParts == 1) {
						MyMessageDlg(0, langConv("警告"), langConv("可動ピンは２つ以上の部品を接続します。"), null)
						document.getElementById("edit").checked = true;
						selectToolKind = "edit";
					}

				//既にピンが配置されている
				} else {
					MyMessageDlg(0, langConv("警告"), langConv("すでにピンが配置されています。"), null)
					document.getElementById("edit").checked = true;
					selectToolKind = "edit";
				}
			}
		}
		
		//ツールが「pinFix(62)」の場合
		else if (kind == "pinFix") {
			//直近（5px以内）の接続穴の座標とParts[]Indexを取得（無い場合は、Parts[]Index=-1が返る）
			var tmpPos = new GetNearHoleByAllParts(x, y);
			//直近に接続穴あり
			if (tmpPos.idx != -1) {
				//既にピンが配置されている場合は終了（新たなピンは配置しない）
				if (IsPin(tmpPos.x, tmpPos.y) == -1) {
		              //パーツへの固定ピンのセット
		              SetPin(1, tmpPos.x, tmpPos.y);
				} else {
					MyMessageDlg(0, langConv("警告"), langConv("すでにピンが配置されています。"), null)
					document.getElementById("edit").checked = true;
					selectToolKind = "edit";
				}
			}
		}
		
		//ツールが「pencil1～pencil4(101～104)」の場合
		else if (kind == "pencilBlack" || kind == "pencilBlue" || kind == "pencilRed" || kind == "pencilGreen") {
			//直近（5px以内）の接続穴の座標とParts[]Indexを取得（無い場合は、Parts[]Index=-1が返る）
			var tmpPos = new GetNearHoleByAllParts(x, y);
			//直近に接続穴あり
			if (tmpPos.idx != -1) {
				//既にペンが配置されている場合は終了（新たなピンは配置しない）
				if (IsPen(tmpPos.x, tmpPos.y) == "") {
					//パーツへのペンのセット
					if (kind == "pencilBlack") {
						var penType = "black";
					} else if (kind == "pencilBlue") {
						var penType = "blue";
					} else if (kind == "pencilRed") {
						var penType = "red";
					} else {
						var penType = "green";
					}
					if (SetPen(penType, tmpPos.x, tmpPos.y) == 1) {
						if (penType == "black") {
							penBlackFlag = true;
						} else if (penType == "blue") {
							penBlueFlag = true;
						} else if (penType == "red") {
							penRedFlag = true;
						} else {
							penGreenFlag = true;
						}
					}
				} else {
					MyMessageDlg(0, langConv("警告"), langConv("すでにペンが配置されています。"), null)
					document.getElementById("edit").checked = true;
					selectToolKind = "edit";
				}
			}
		}

		//再描画
		redrawCanvas();
		
		//連続配置
		if (ctrl == false) {
			document.getElementById("edit").checked = true;
			selectToolKind = "edit";
		}
	}
}

//----------------------------------------------------------
//	クリック位置のパーツを削除
//----------------------------------------------------------
var delIdx, delX, delY;
function delParts(x, y, ctrl) {
	var i, j;
	var delFlag;
	var xD, yD;
	var pt;
	var r, p;

	//パーツ番号の取得（canvasPosの座標色からパーツIdxを取得）
	selectPartsIdx = -1;
	var imagedata = contextPos.getImageData(x, y, 1, 1);
	var idx = imagedata.data[0];				//赤が、partsのidx
	
	//パーツがない部分は、255となる
	if (idx < partsCount) {
	
		var Pos = new GetNearHolePosition(idx, x, y, 5);

		//ペンの削除
		if (IsPen(Pos.x, Pos.y) != "") {
			//-----------------------------
			//パーツ idx のペン  の削除処理
			//-----------------------------
			delIdx = idx;
			delX = Pos.x;
			delY = Pos.y;
			
			if (ctrl == false) {
				MyMessageDlg(1, langConv("確認"), langConv("ペンを削除します。よいですか？"), delPartsPen);
			} else {
				delPartsPen();
			}
		}

		//ピンの削除
		else if (IsPin(Pos.x, Pos.y) > -1) {
			//-----------------------------
			//円盤と動力ロッドの中心ピンは削除できない（動力ピストンの接続部は、ピンではない）
			//-----------------------------
			if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk2Power" ||
				parts[idx].kind == "disk1" || parts[idx].kind == "disk2" || parts[idx].kind == "disk3" ||
				parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") {
				if (CmpPosition(Pos.x, Pos.y, parts[idx].x, parts[idx].y) == true) {
					MyMessageDlg(0, langConv("警告"), langConv("円盤の中心のピンは、削除できません。"), null);
					return;
				}
			}

			//-----------------------------
			//パーツ idx のピン  の削除処理
			//-----------------------------
			delIdx = idx;
			delX = Pos.x;
			delY = Pos.y;
			if (ctrl == false) {
				MyMessageDlg(1, langConv("確認"), langConv("ピンを削除します。よいですか？"), delPartsPin);
			} else {
				delPartsPin();
			}
		}

		//パーツの削除
		else {
			//-----------------------------
			//ピンの接続されているパーツは削除できない
			//-----------------------------
			//円盤と動力ロッドは中心ピンがあるので２個以上
			if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk3Power" ||
				parts[idx].kind == "disk1" || parts[idx].kind == "disk2" || parts[idx].kind == "disk3" ||
				parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") {
				if (parts[idx].pinCount >= 2) {
					MyMessageDlg(0, langConv("警告"), langConv("中心以外にピンが接続されているので、削除できません。"), null);
					return;
				}

			} else {
				if (parts[idx].pinCount >= 1) {
					MyMessageDlg(0, langConv("警告"), langConv("ピンが接続されているので、削除できません。"), null);
					return;
				}
			}

			//-----------------------------
			//ペンの接続されているパーツは削除できない
			//-----------------------------
			if (parts[idx].penCount > 0) {
				MyMessageDlg(0, langConv("警告"), langConv("ペンが接続されているので、削除できません。"), null);
				return;
			}

			//-----------------------------
			//パーツ idx の削除処理
			//-----------------------------
			delIdx = idx;
			delX = Pos.x;
			delY = Pos.y;
			if (ctrl == false) {
				MyMessageDlg(1, langConv("確認"), langConv("部品を削除します。よいですか？"), delPartsBody);
			} else {
				delPartsBody();
			}
		}
		
		//連続配置
		if (ctrl == false) {
			document.getElementById("edit").checked = true;
			selectToolKind = "edit";
		}
	}
}

//----------------------------------------------------------
//	parts[idx]のペンの削除
//----------------------------------------------------------
function delPartsPen() {

	var p;
	var delFlag;
	var xD, yD;
	var pt;
	
	for (var j = 0; j < partsCount; j++) {

		var x = parts[j].x;
		var y = parts[j].y;
		var angle = parts[j].a;
		var r = parts[j].r;

		if (parts[j].kind == "piston1Power" || parts[j].kind == "piston2Power" || 
			parts[j].kind == "piston1" || parts[j].kind == "piston2") {
			while (r > 360) {
				r = r - 360;
			}
			while (r < 0) {
				r = r + 360;
			}
			if (r > 180) {
				p = 360 - r;
			} else {
				p = r;
			}
		} else {
			p = 0;
		}

		delFlag = -1;

		for (i = 0; i < parts[j].penCount; i++) {
			xD = rotateX(x, y, x+parts[j].penX[i]+p, y+parts[j].penY[i], angle);
			yD = rotateY(x, y, x+parts[j].penX[i]+p, y+parts[j].penY[i], angle);

			if (CmpPosition(xD, yD, delX, delY) == true) {
				delFlag = i;
				pt = parts[j].penType[i];
				break;
			}
		}

		if (delFlag > -1) {
			for (i = delFlag; i < parts[j].penCount-1; i++) {
				parts[j].penType[i] = parts[j].penType[i+1];
				parts[j].penX[i]    = parts[j].penX[i+1];
				parts[j].penY[i]    = parts[j].penY[i+1];
			}
			parts[j].penCount--;

			if (pt == "black") {
				penBlackFlag = false;
				//lstPen1X.Clear;
				//lstPen1Y.Clear;
			} else if (pt == "blue") {
				penBlueFlag = false;
				//lstPen2X.Clear;
				//lstPen2Y.Clear;
			} else if (pt == "red") {
				penRedFlag = false;
				//lstPen3X.Clear;
				//lstPen3Y.Clear;
			} else if (pt == "green") {
				penGreenFlag = false;
				//lstPen4X.Clear;
				//lstPen4Y.Clear;
			}
		}
	}

	//再描画
	redrawCanvas();
}

//----------------------------------------------------------
//	parts[idx]のピンの削除
//----------------------------------------------------------
function delPartsPin() {

	var p;
	var delFlag;
	var xD, yD;
	var pt;

	for (var j = 0; j < partsCount; j++) {

		var x = parts[j].x;
		var y = parts[j].y;
		var angle = parts[j].a;
		var r = parts[j].r;

		if (parts[j].kind == "piston1Power" || parts[j].kind == "piston2Power" || 
			parts[j].kind == "piston1" || parts[j].kind == "piston2") {
			while (r > 360) {
				r = r - 360;
			}
			while (r < 0) {
				r = r + 360;
			}
			if (r > 180) {
				p = 360 - r;
			} else {
				p = r;
			}
		} else {
			p = 0;
		}

		delFlag = -1;

		for (i = 0; i < parts[j].pinCount; i++) {
			xD = rotateX(x, y, x+parts[j].pinX[i]+p, y+parts[j].pinY[i], angle);
			yD = rotateY(x, y, x+parts[j].pinX[i]+p, y+parts[j].pinY[i], angle);

			if (CmpPosition(xD, yD, delX, delY) == true) {
				delFlag = i;
				break;
			}
		}

		if (delFlag > -1) {
			for (i = delFlag; i < parts[j].pinCount-1; i++) {
				parts[j].pinIndex[i] = parts[j].pinIndex[i+1];
				parts[j].pinType[i]  = parts[j].pinType[i+1];
				parts[j].pinX[i]     = parts[j].pinX[i+1];
				parts[j].pinY[i]     = parts[j].pinY[i+1];
			}
			parts[j].pinCount--;
		}
	}

	//再描画
	redrawCanvas();
}

//----------------------------------------------------------
//	parts[idx]の削除
//----------------------------------------------------------
function delPartsBody() {

	//動力パーツの場合
	if (parts[delIdx].kind == "disk1Power" || parts[delIdx].kind == "disk2Power" || parts[delIdx].kind == "disk3Power" ||
		parts[delIdx].kind == "piston1Power" || parts[delIdx].kind == "piston2Power" ||
		parts[delIdx].kind == "rod1Power" || parts[delIdx].kind == "rod2Power") {

		powerFlag = false;
		powerPartsIndex = -1;
		//TrackBar1.Enabled := False;
		//cmbSpeed.Enabled := False;
		//btnPlay.Enabled := False;
		//btnBack.Enabled := False;
	}

	for (i = delIdx; i < partsCount-1; i++) {
		parts[i] = parts[i+1];
	}
	partsCount--;

	//再描画
	redrawCanvas();
}

//##########################################################
//	パーツの編集
//##########################################################
//----------------------------------------------------------
//	編集時のマウスダウン（移動等の開始）
//----------------------------------------------------------
function editMouseDown(x, y, ctrl, shift) {

	//パーツ番号の取得（canvasPosの座標色からパーツIdxを取得）
	selectPartsIdx = -1;
	var imagedata = contextPos.getImageData(x, y, 1, 1);
	var tmpIdx = imagedata.data[0];				//赤が、partsのidx
	
	//パーツがない部分は、255となる
	if (tmpIdx < partsCount) {
		selectPartsIdx = tmpIdx;

		//クリックした位置の選択パーツの描画色の取得（スライドロッドで中心ピン識別のため）
		var imagedata = context.getImageData(x, y, 1, 1);
		var DownColor = imagedata.data[0];

		//クリックした位置の選択パーツ原点とのオフセットを取得
		var pos = new GetNearHolePosition(selectPartsIdx, x, y, 8);
		offsetX = parts[selectPartsIdx].x - pos.x;
		offsetY = parts[selectPartsIdx].y - pos.y;

		downPX = Math.round(parts[selectPartsIdx].x);
		downPY = Math.round(parts[selectPartsIdx].y);

		downX = x;
		downY = y;

		prevX = x;
		prevY = y;

		//---------------------------------------------------------------
		//スライドロッドで中心ピン（193と17は、中心ピンの特殊色）
		//---------------------------------------------------------------
		if (DownColor == 193 || DownColor == 17) {
			intJob = 20;
			
		//---------------------------------------------------------------
		//ピストンの可動部分の場合（203と254は、ピストンの可動部分の特殊色）
		//---------------------------------------------------------------
		} else if (DownColor == 203 ||  DownColor == 254) {
			//ピストンにピンが接続されている場合は、移動不可
			if (parts[selectPartsIdx].pinCount == 0) {
				intJob = 0;  //移動できない
				imgDisplayMouseMoveFlag = False;
			} else {
				intJob = 20;
			}

		//---------------------------------------------------------------
		//パーツの本体部分
		//---------------------------------------------------------------
		} else {
			//---------------------------------------------------------------
			//現在の処理番号の設定
			//選択部品にピンが無い場合は、自由移動（intJob=2）
			//選択部品にピンが１つの場合は、回転（intJob=3）
			//選択部品にピンが２つ以上の場合は、処理なし（intJob=0）
			//---------------------------------------------------------------
			switch (parts[selectPartsIdx].pinCount) {
				case 0:  //接続ピンがない（平行移動　あるいは　回転（Ｓｈｉｆｔキーが押されている場合））
					downAngle = RadToDeg(Math.atan2((downY - downPY), (downX - downPX)));
					intJob = 2;
					break;

				case 1:  //接続ピンが１つ
					//１つの接続ピンが固定ピン かつ　円盤、動力ロッド（平行移動　あるいは　回転（Ｓｈｉｆｔキーが押されている場合））
					if (parts[selectPartsIdx].pinType[0] == 1 && 
						(parts[selectPartsIdx].kind == "disk1Power" || parts[selectPartsIdx].kind == "disk2Power" || parts[selectPartsIdx].kind == "disk3Power" ||
						 parts[selectPartsIdx].kind == "disk1" || parts[selectPartsIdx].kind == "disk2" || parts[selectPartsIdx].kind == "disk3" ||
						 parts[selectPartsIdx].kind == "rod1Power" || parts[selectPartsIdx].kind == "rod2Power")) {
						downAngle = RadToDeg(Math.atan2((downY - downPY),(downX - downPX)));
						intJob = 2;

					//１つの接続ピンが固定ピン（自部品の回転のみ）
					} else if (parts[selectPartsIdx].pinType[0] == 1) {
						xx = parts[selectPartsIdx].x;
						yy = parts[selectPartsIdx].y;
						angle = parts[selectPartsIdx].a;
						xD = rotateX(xx, yy, xx+parts[selectPartsIdx].pinX[0], yy+parts[selectPartsIdx].pinY[0], angle);
						yD = rotateY(xx, yy, xx+parts[selectPartsIdx].pinX[0], yy+parts[selectPartsIdx].pinY[0], angle);
						downAngle = RadToDeg(Math.atan2((downY - yD), (downX - xD)));
						intJob = 3;

					//１つの接続ピンが可動ピン
					} else {
						xx = parts[selectPartsIdx].x;
						yy = parts[selectPartsIdx].y;
						angle = parts[selectPartsIdx].a;
						r = parts[selectPartsIdx].r;

						if (parts[selectPartsIdx].kind == "piston1Power" || parts[selectPartsIdx].kind == "piston2Power" || 
							parts[selectPartsIdx].kind == "piston1" || parts[selectPartsIdx].kind == "piston2") {
							while (r > 360) {
								r = r - 360;
							}
							while (r < 0) {
								r = r + 360;
							}
							if (r > 180) {
								p = 360 - r;
							} else {
								p = r;
							}
						} else {
							p = 0;
						}
						xD = rotateX(xx, yy, xx+parts[selectPartsIdx].pinX[0]+p, yy+parts[selectPartsIdx].pinY[0], angle);
						yD = rotateY(xx, yy, xx+parts[selectPartsIdx].pinX[0]+p, yy+parts[selectPartsIdx].pinY[0], angle);
						downAngle = RadToDeg(Math.atan2((downY - yD),(downX - xD)));

						var cnt = GetPartsNumberForPinPosition(xD, yD, -1);
						if (cnt > 2) {
							intJob = 3;  //パーツにピンが２個以上接続されている場合は、自部品の回転のみ
						} else {
							if (GetPartsNumberForPinPosition(xD, yD, 0) == selectPartsIdx) {
								downConnectPartsNo = GetPartsNumberForPinPosition(xD, yD, 1);
							} else {
								downConnectPartsNo = GetPartsNumberForPinPosition(xD, yD, 0);
							}

							if (parts[downConnectPartsNo].pinCount == 1) {
								intJob = 4;  //自部品の回転　あるいは　自部品の平行移動と接続部品の平行移動
							
							} else if (parts[downConnectPartsNo].pinCount == 2) {
								intJob = 5;  //自部品の回転　あるいは　自部品の平行移動と接続部品の回転
								downPX2 = Math.round(parts[downConnectPartsNo].x);
								downPY2 = Math.round(parts[downConnectPartsNo].y);
							} else {
								intJob = 3;  //自部品の回転のみ
							}
						}
					}
					break;
				
				//接続ピンが複数
				defaule:
					intJob = 0;  //移動できない
					imgDisplayMouseMoveFlag = False;
					break;
			}

		}
		//---------------------------------------------------------
		//共通処理
		//---------------------------------------------------------
		if (intJob > 0) {
			parts[selectPartsIdx].transparent = true;
			if (intJob == 4 || intJob == 5) {
				parts[downConnectPartsNo].transparent = true;
			}
			redrawCanvas();
			
			var imagedata = contextPos.getImageData(x, y, 1, 1);
			var tmpIdx = imagedata.data[0];				//赤が、partsのidx
		}
	}
}

//----------------------------------------------------------
//	編集時のマウスムーブ（移動等の途中）
//----------------------------------------------------------
function editMouseMove(x, y, ctrl, shift) {

	if (selectPartsIdx == -1 || selectPartsIdx >= partsCount) return;

	if (intJob < 2) return;

	var idx = selectPartsIdx;

	//shiftキーが押されている
	if (shift == true) {
		switch (intJob) {
			case 2:
				sJob = 3;
				break;
			case 3:
				sJob = 4;
				break;
			case 4:
				sJob = 5;
				break;
			case 5:
				sJob = 6;
				break;
			case 20:			//スライドロッドで中心ピン or ピストンの場合（193と17は、中心ピンの特殊色。203と254は、ピストンの特殊色）
				sJob = 3;
				break;
			default:
				sJob = -1;
				break;
		}
	} else {
		switch (intJob) {
			case 2:
				sJob = 2;
				break;
			case 3:
				sJob = 4;
				break;
			case 4:
				sJob = 4;
				break;
			case 5:
				sJob = 4;
				break;
			case 20:			//スライドロッドで中心ピン or ピストンの場合（193と17は、中心ピンの特殊色。203と254は、ピストンの特殊色）
				sJob = 2;
				break;
			default:
				sJob = -1;
				break;
		}
	}

	//===================================================================
	//ＳＨＩＦＴなし（自由移動）
	//===================================================================
	if (sJob == 2) {
		//ピストン
		if (intJob == 20 && (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2")) {

			aa = parts[idx].a;

			while (aa > 360) {
				aa = aa - 360;
			}
			while (aa < 0) {
				aa = aa + 360;
			}
			if (aa >= 0 && aa < 45) {
				mm = (x - prevX) * -1;
			} else if (aa >=  45 && aa < 135) {
				mm = (y - prevY) * -1;
			} else if (aa >= 135 && aa < 225) {
				mm = x - prevX;
			} else if (aa >= 225 && aa < 315) {
				mm = y - prevY;
			} else {
				mm = (x - prevX) * -1;
			}

			if (parts[idx].r - mm >= 0 && parts[idx].r - mm <= 180) {
				parts[idx].r = parts[idx].r - mm;
			}
			
			//動力ピストンの場合、トラックバーを動かす(parts[idx].r : 0～180)
			if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power") {
				document.getElementById("trackBar").value = Math.floor(((parts[idx].r) / 180) * 359 + 180);
				prevTrackBarPosition = document.getElementById("trackBar").value;
			}

		//スライドロッド
		} else if (intJob == 20 && (parts[idx].kind == "rodSlide1" || parts[idx].kind == "rodSlide2")) {

			aa = parts[idx].a;

			while (aa > 360) {
				aa = aa - 360;
			}
			while (aa < 0) {
				aa = aa + 360;
			}
			if (aa == 0) {
				mm = (x - prevX) * -1;
			} else if (aa == 90) {
				mm = (y - prevY) * -1;
			} else if (aa == 180) {
				mm = (x - prevX) * +1;
			} else if (aa == 270) {
				mm = (y - prevY) * +1;
			} else if (aa == 360) {
				mm = (x - prevX) * -1;
			} else if (aa > 0 && aa < 45) {
				mm = ((x - prevX) * -1) / Math.cos(DegToRad(aa));
			} else if (aa >=  45 && aa < 135) {
				mm = ((y - prevY) * -1) / Math.sin(DegToRad(aa));
			} else if (aa >= 135 && aa < 225) {
				mm = ((x - prevX) * -1) / Math.cos(DegToRad(aa));
			} else if (aa >= 225 && aa < 315) {
				mm = ((y - prevY) * -1) / Math.sin(DegToRad(aa));
			} else {
				mm = ((x - prevX) * -1) / Math.cos(DegToRad(aa));
			}

			if (parts[idx].kind == "rodSlide2") {
				if (parts[idx].r - mm >= 60 && parts[idx].r - mm <= 340) {
					parts[idx].r = parts[idx].r - mm;
				}
			}
			
			if (parts[idx].kind == "rodSlide1") {
				if (parts[idx].r - mm >= 60 && parts[idx].r - mm <= 180) {
					parts[idx].r = parts[idx].r - mm;
				}
			}

		//ピストンとスライドロッド以外
		} else {
			var imagedata = contextPos.getImageData(x, y, 1, 1);
			var tmpIdx = imagedata.data[0];				//赤が、partsのidx

			//別のパーツの上でない場合（グリッドに吸着）パーツがない部分は、255となる
			if (tmpIdx >= partsCount) {
				parts[idx].x = FitGrid(x + offsetX);
				parts[idx].y = FitGrid(y + offsetY);
			//別のパーツの上の場合（接続穴に吸着）
			} else {
				var pos = new GetNearHolePosition(tmpIdx, x, y, 8);
				parts[idx].x = pos.x + offsetX;
				parts[idx].y = pos.y + offsetY;
			}
		}

		prevX = x;
		prevY = y;
		redrawCanvas();
	}

	//===================================================================
	//ＳＨＩＦＴあり（原点を中心とした自部品の回転）
	//===================================================================
	else if (sJob == 3) {

		xt = parts[idx].x;
		yt = parts[idx].y;

		CenterX = xt;     //回転中心
		CenterY = yt;     //回転中心

		//現在の位置の角度
		a2 = RadToDeg(Math.atan2((y - CenterY), (x - CenterX))) - downAngle;
		downAngle = RadToDeg(Math.atan2((y - CenterY), (x - CenterX)));
		
		//回転処理
		RotateParts(idx, a2);

		//動力円盤or動力ロッドの場合、トラックバーを動かす
		if (parts[idx].kind == "disk1Power" || parts[idx].kind == "disk2Power" || parts[idx].kind == "disk3Power" ||
			parts[idx].kind == "rod1Power" || parts[idx].kind == "rod2Power") {
			
			var tmp = Math.floor(parts[idx].a);
			if (tmp <= 180) {
				tmp = tmp+360;
			} else {
				tmp = tmp;
			}
			document.getElementById("trackBar").value = Math.floor(tmp);
			prevTrackBarPosition = document.getElementById("trackBar").value;
		}

		prevX = x;
		prevY = y;
		redrawCanvas();
	}
	
	//===================================================================
	//左ボタンが押されている場合（ピンを中心とした自部品の回転）
	//===================================================================
	else if (sJob == 4) {
		//マウス位置にある部品の番号を取得
		//s := PositionBitmap.Canvas.Pixels[X, Y];
		var imagedata = contextPos.getImageData(x, y, 1, 1);
		var tmpIdx = imagedata.data[0];				//赤が、partsのidx

		//マウス位置の直近の自部品の接続穴の座標を取得
		//Pos1.X := X;
		//Pos1.Y := Y;
		Pos1 = new GetNearHolePosition(idx, x, y, 8);

		//マウス位置にある部品の直近の接続穴の座標を取得
		//Pos2.X := X;
		//Pos2.Y := Y;
		//if (tmpIdx < partsCount) {							//マウス上に部品がある？
		//	if (parts[tmpIdx].pinCount == 1) {				//その部品にピンが１つ（回転中心）？
		//		//Pos2 = new GetNearHolePosition(tmpIdx, x, y, 12);
		//	}
		//}
		Pos2 = new GetNearHolePosition(tmpIdx, x, y, 12);

		//----------------------------------------------------------------
		//パーツの上の連結穴の近くでない場合（吸着しない）
		if (tmpIdx >= partsCount || (Pos1.x == x && Pos1.y == y) || (Pos2.x == x && Pos2.y == y)) {
			xt = parts[idx].x;
			yt = parts[idx].y;
			at = parts[idx].a;
			r = parts[idx].r;

			if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}
			} else {
				p = 0;
			}

			CX = xt + parts[idx].pinX[0]+p;
			CY = yt + parts[idx].pinY[0];
			CenterX = rotateX(xt, yt, CX, CY, at);     //回転中心
			CenterY = rotateY(xt, yt, CX, CY, at);     //回転中心

			//現在の位置の角度
			a2 = RadToDeg(Math.atan2((y - CenterY), (x - CenterX))) - downAngle;
			downAngle = RadToDeg(Math.atan2((y - CenterY), (x - CenterX)));

			//回転処理
			RotateParts(idx, a2);

		//部品上の連結穴の近くの場合（直近の接続穴に吸着、マウス位置にある部品の回転移動を含む）
		} else {
			//自部品の回転中心
			xt = parts[idx].x;
			yt = parts[idx].y;
			at = parts[idx].a;
			r = parts[idx].r;

			if (parts[idx].kind == "piston1Power" || parts[idx].kind == "piston2Power" || parts[idx].kind == "piston1" || parts[idx].kind == "piston2") {
				while (r > 360) {
					r = r - 360;
				}
				while (r < 0) {
					r = r + 360;
				}
				if (r > 180) {
					p = 360 - r;
				} else {
					p = r;
				}
			} else {
				p = 0;
			}

			CX = xt + parts[idx].pinX[0]+p;
			CY = yt + parts[idx].pinY[0];
			CenterX = rotateX(xt, yt, CX, CY, at);     //回転中心
			CenterY = rotateY(xt, yt, CX, CY, at);     //回転中心

			//自部品の回転中心と半径
			x1 = CenterX;
			y1 = CenterY;
			r1 = Math.sqrt((CenterX - Pos1.x)**2 + (CenterY - Pos1.y)**2);

			//他部品の回転中心
			xt = parts[tmpIdx].x;
			yt = parts[tmpIdx].y;
			at = parts[tmpIdx].a;
			CX = xt + parts[tmpIdx].pinX[0];
			CY = yt + parts[tmpIdx].pinY[0];
			CenterX = rotateX(xt, yt, CX, CY, at);     //回転中心
			CenterY = rotateY(xt, yt, CX, CY, at);     //回転中心

			//他部品の回転中心と半径
			x2 = CenterX;
			y2 = CenterY;
			r2 = Math.sqrt((CenterX - Pos2.x)**2 + (CenterY - Pos2.y)**2);

			//２つの円の交点座標を求める
			cPos = new GetCircleToCircleCrossPoint(x1, y1, r1, x2, y2, r2);

			//交点がない
			if (cPos.ResultCode == 0) {
				return;
			//交点がある（１つの交点 or ２つの交点）
			} else {
				//マウス位置に近い方の交点を採用する
				l1 = Math.sqrt((cPos.x1 - x)**2 + (cPos.y1 - y)**2);
				l2 = Math.sqrt((cPos.x2 - x)**2 + (cPos.y2 - y)**2);
				if (l1 < l2) {
					xt = cPos.x1;
					yt = cPos.y1;
				} else {
					xt = cPos.x2;
					yt = cPos.y2;
				}
			}

			//-------------------------------------
			//自部品の回転
			//-------------------------------------
			//現在の位置の角度
			a1 = RadToDeg(Math.atan2((yt - y1), (xt - x1))) - RadToDeg(Math.atan2((Pos1.y - y1), (Pos1.x - x1)));
			downAngle = RadToDeg(Math.atan2((yt - y1), (xt - x1)));

			//回転処理
			RotateParts(idx, a1);

			//-------------------------------------
			//他部品の回転
			//-------------------------------------
			//距離の算出
			l1 = Math.sqrt((x2 - parts[tmpIdx].x)**2 + (y2 - parts[tmpIdx].y)**2);		//回転中心と部品原点の距離
			l2 = Math.sqrt((xt - parts[tmpIdx].x)**2 + (yt - parts[tmpIdx].y)**2);		//移動点と部品原点の距離

			//現在の位置の角度
			a2 = RadToDeg(Math.atan2((yt - y2), (xt - x2))) - RadToDeg(Math.atan2((Pos2.y - y2), (Pos2.x - x2)));

			//回転処理
			RotateParts(tmpIdx, a2);
		}

		prevX = x;
		prevY = y;
		redrawCanvas();
	}

	//===================================================================
	//左ボタンが押されている場合（自部品の平行移動と接続部品の平行移動）
	//===================================================================
	else if (sJob == 5) {
		xo = parts[idx].x;
		yo = parts[idx].y;

		//s := PositionBitmap.Canvas.Pixels[X, Y];
		var imagedata = contextPos.getImageData(x, y, 1, 1);
		var tmpIdx = imagedata.data[0];				//赤が、partsのidx

		//パーツの上でない場合（グリッドに吸着）
		if (tmpIdx >= partsCount) {
			parts[idx].x = FitGrid(x + offsetX);
			parts[idx].y = FitGrid(y + offsetY);

			parts[downConnectPartsNo].x = parts[downConnectPartsNo].x - (xo - parts[idx].x);
			parts[downConnectPartsNo].y = parts[downConnectPartsNo].y - (yo - parts[idx].y);
        
        //パーツの上の場合（接続穴に吸着）
		} else {
			Pos = new GetNearHolePosition(tmpIdx, x, y, 8);

			parts[idx].x = Pos.x;
			parts[idx].y = Pos.y;

			parts[downConnectPartsNo].x = parts[downConnectPartsNo].x - (xo - parts[idx].x);
			parts[downConnectPartsNo].y = parts[downConnectPartsNo].y - (yo - parts[idx].y);
		}

		prevX = x;
		prevY = y;
		redrawCanvas();
	}

	//===================================================================
	//左ボタンが押されている場合（接続部品の回転とそれに合わせた自部品の回転）
	//===================================================================
	else if (sJob == 6) {

		//接続部品の回転中心のピン番号の取得（pno）
		xD1 = rotateX(parts[idx].x,
						parts[idx].y,
						parts[idx].x+parts[idx].pinX[0],
						parts[idx].y+parts[idx].pinY[0],
						parts[idx].a);
		yD1 = rotateY(parts[idx].x,
						parts[idx].y,
						parts[idx].x+parts[idx].pinX[0],
						parts[idx].y+parts[idx].pinY[0],
						parts[idx].a);

		xD2 = rotateX(parts[downConnectPartsNo].x,
						parts[downConnectPartsNo].y,
						parts[downConnectPartsNo].x+parts[downConnectPartsNo].pinX[0],
						parts[downConnectPartsNo].y+parts[downConnectPartsNo].pinY[0],
						parts[downConnectPartsNo].a);

		yD2 = rotateY(parts[downConnectPartsNo].x,
						parts[downConnectPartsNo].y,
						parts[downConnectPartsNo].x+parts[downConnectPartsNo].pinX[0],
						parts[downConnectPartsNo].y+parts[downConnectPartsNo].pinY[0],
						parts[downConnectPartsNo].a);

		if (CmpPosition(xD1, yD1, xD2, yD2) == true) {
			pno = 1;
		} else {
			pno = 0;
		}
		
		//回転中心（CenterX,CenterY）の算出
		xt = parts[downConnectPartsNo].x;
		yt = parts[downConnectPartsNo].y;
		at = parts[downConnectPartsNo].a;

		CX = xt + parts[downConnectPartsNo].pinX[pno];     //回転中心
		CY = yt + parts[downConnectPartsNo].pinY[pno];     //回転中心

		CenterX = rotateX(xt, yt, CX, CY, at);
		CenterY = rotateY(xt, yt, CX, CY, at);


		//回転中心とマウスのダウン位置の距離が近すぎる場合は終了
		//距離の算出

		//直前のマウス位置（prevX,prevY）と回転中心（CenterX,CenterY）の角度（a1）
		a1 = RadToDeg(Math.atan2((prevY - CenterY), (prevX - CenterX)));

		//現在のマウス位置（X,Y）と回転中心（CenterX,CenterY）の角度（a2）
		a2 = RadToDeg(Math.atan2((y - CenterY), (x - CenterX)));

		//------------------------
		//自部品の回転移動
		//------------------------
		xD = rotateX(CenterX, CenterY, parts[idx].x, parts[idx].y, a2-a1);
		yD = rotateY(CenterX, CenterY, parts[idx].x, parts[idx].y, a2-a1);

		parts[idx].x = xD;
		parts[idx].y = yD;
		parts[idx].a = parts[idx].a + (a2-a1);

		//------------------------
		//接続部品の回転移動
		//------------------------
		xD = rotateX(CenterX, CenterY, parts[downConnectPartsNo].x, parts[downConnectPartsNo].y, a2-a1);
		yD = rotateY(CenterX, CenterY, parts[downConnectPartsNo].x, parts[downConnectPartsNo].y, a2-a1);

		parts[downConnectPartsNo].x = xD;
		parts[downConnectPartsNo].y = yD;
		parts[downConnectPartsNo].a = parts[downConnectPartsNo].a + (a2-a1);

		prevX = x;
		prevY = y;
		redrawCanvas();
	}
}

//----------------------------------------------------------
//	編集時のマウスアップ（移動等の終了）
//----------------------------------------------------------
function editMouseUp() {

	if (selectPartsIdx == -1 || selectPartsIdx >= partsCount) return;

	if (intJob == 2 || intJob == 20 || intJob == 3 || intJob == 4 || intJob == 5) {

		parts[selectPartsIdx].transparent = false;

		if (intJob == 4 || intJob == 5) {
			parts[downConnectPartsNo].transparent = false;
		}
		
		//--------------------------------------------
		//独立パーツがエリア外に出た場合は、削除する
		//--------------------------------------------
/*
		//独立パーツか否かの判定
		if ((Parts[intSelectPartsNumber].PinCount = 0) and (Parts[intSelectPartsNumber].ShapeType > 30)) or			//通常パーツで接続ピンがない場合
			((Parts[intSelectPartsNumber].PinCount = 1) and (Parts[intSelectPartsNumber].ShapeType < 30)) then		//回転パーツで接続ピンが１つの場合
			//削除できるパーツの場合の処理
			//エリア外か否かの判定
			if (Parts[intSelectPartsNumber].X < 0) or (Parts[intSelectPartsNumber].X > imgDisplay.Width) or     //X軸方向がエリア外の場合
				(Parts[intSelectPartsNumber].Y < 0) or (Parts[intSelectPartsNumber].Y > imgDisplay.Height) then  //Y軸方向がエリア外の場合
				//削除する場合の処理
				//削除する旨のメッセージの表示
				//if intLangage = 1041 then MessageString := 'パーツがエリア外に出たので削除します。'
				//else                      MessageString := 'Part came outside area, it delete.';
				//MessageDlg(MessageString, mtInformation, [mbOK], 0);

				//ペンを削除する処理
				Parts[intSelectPartsNumber].PenCount := 0;

				Pen1Flag := False;
				lstPen1X.Clear;
				lstPen1Y.Clear;

				Pen2Flag := False;
				lstPen2X.Clear;
				lstPen2Y.Clear;

				Pen3Flag := False;
				lstPen3X.Clear;
				lstPen3Y.Clear;

				Pen4Flag := False;
				lstPen4X.Clear;
				lstPen4Y.Clear;

				//パーツを削除する処理
				if (Parts[intSelectPartsNumber].ShapeType < 20) or (Parts[intSelectPartsNumber].ShapeType = 91) or (Parts[intSelectPartsNumber].ShapeType = 93) then
					MoterFlag := False;
					TrackBar1.Enabled := False;
					cmbSpeed.Enabled := False;
					btnPlay.Enabled := False;
					btnBack.Enabled := False;
					MoterPartsNumber := -1;
				}

				for i := intSelectPartsNumber to intCurrentPartsNumber - 2 do
					parts[i] := parts[i+1];
				}

				intCurrentPartsNumber := intCurrentPartsNumber - 1;

			}
		}
*/


		redrawCanvas();

		//現在の処理番号の開放
		intJob = -1;

	} else if (intJob == 0) {
		intJob = -1;
	}
}


