﻿//==========================================================
//	linksim-move.js by LinkSim for Web
//==========================================================
//**************  Debug  ********************************************
var Level = 0;
var MessageString;
//**************  Debug  ********************************************
//-----------------------------------------------------------
//  トラックバーの位置に合わせてパーツを動かす
//-----------------------------------------------------------
function moveParts() {
	var i, ii;
	var disX, disY;
	var srcX, srcY;
	var x, y, angle;
	var PrevA;
	var res;
	var partsP = [];
	var CanMoveFlagT;
	var CanMoveFlagF;
	var s;
	var r, p;
	var pc;
	var ErrorCount;
	
	
	if (isLockScreen == true) return 12;
	
	//動力パーツがない
	if (powerPartsIndex == -1) return 13;

	//動力部品の種類
	if (parts[powerPartsIndex].kind == "disk1Power" || parts[powerPartsIndex].kind == "disk2Power" || parts[powerPartsIndex].kind == "disk3Power" || 
		parts[powerPartsIndex].kind == "rod1Power" || parts[powerPartsIndex].kind == "rod2Power") {
		s = 1;		//動力円盤、動力ロッド
	} else {
		s = 0;		//動力ピストン
	}

	//-------------------------------------------------------------
	//動力円盤、動力ロッドに他の部品が接続されていない場合は、動力円盤、動力ロッドのみの回転
	//-------------------------------------------------------------
	if (s == 1 && parts[powerPartsIndex].pinCount == 1) {
		parts[powerPartsIndex].a = TrackBarPosition;
		AdjustAngle(powerPartsIndex);
		//再描画
		redrawCanvas();
		prevTrackBarPosition = TrackBarPosition;
		return 0;
	}

	//-------------------------------------------------------------
	//動力ピストンに他の部品が接続されていない場合は、動力ピストンのみの回転
	//-------------------------------------------------------------
	if (s == 0 && parts[powerPartsIndex].pinCount == 0) {
		parts[powerPartsIndex].r = (TrackBarPosition-90) % 360;
		//再描画
		redrawCanvas();
		prevTrackBarPosition = TrackBarPosition;
		return 0;
	}

	//=============================================================
	//ここからは、動力円盤に他の部品が接続されてる場合の処理
	//=============================================================
	
	//-------------------------------------------------------------
	//部品情報をテンポラリに退避（partsT ← parts）
	//-------------------------------------------------------------
	pushPartsArr(partsT);

	//-------------------------------------------------------------
	//moveFlagのクリア
	//-------------------------------------------------------------
	for (var ii = 0; ii < partsCount; ii++) {
		parts[ii].moveFlag = 0;
	}

	//-------------------------------------------------------------
	//動力円盤、動力ロッド、動力ピストンの回転
	//-------------------------------------------------------------
	if (s == 1) {
		prevA = parts[powerPartsIndex].a;
		parts[powerPartsIndex].a = TrackBarPosition;
		AdjustAngle(powerPartsIndex);
		parts[powerPartsIndex].moveFlag = 1;
	} else {
		prevA = parts[powerPartsIndex].r;
		parts[powerPartsIndex].r = (TrackBarPosition-90) % 360;
		parts[powerPartsIndex].moveFlag = 1;
	}

	//-------------------------------------------------------------
	//動力円盤のすべての可動ピンについての処理
	//-------------------------------------------------------------
	for (i = s; i < parts[powerPartsIndex].pinCount; i++) {
		if (parts[powerPartsIndex].pinType[i] == 0) {
			//-----------------------------------------------------------
			//接続部品のピンを仮固定ピンとする
			//-----------------------------------------------------------
			ChangePinType2(parts[powerPartsIndex].pinIndex[i], 2);
			//-----------------------------------------------------------
			//動力円盤のすべての可動ピンを固定ピンとする
			//-----------------------------------------------------------
			parts[powerPartsIndex].pinType[i] = 1;
		}
	}

	//-------------------------------------------------------------
	//移動後の回転中心のピンの座標と回転角度
	//-------------------------------------------------------------
	x = parts[powerPartsIndex].x;
	y = parts[powerPartsIndex].y;
	angle = parts[powerPartsIndex].a;

	//**************  Debug  ********************************************
	if (debugMode == true) {
		Level = 0;
		MessageString = langConv('== 動力部品の移動処理開始 ==');
		console.log(MessageString);
	}
	//**************  Debug  ********************************************

	//-------------------------------------------------------------------
	//すべての接続部品についての処理
	//-------------------------------------------------------------------
	CanMoveFlagT = 0;
	CanMoveFlagF = 0;
	ErrorCount = 0;

	while (CanMoveFlagT + CanMoveFlagF < parts[powerPartsIndex].pinCount-s) {
		
		//動力円盤・ロッドの場合s=1、動力ピストンの場合s=0
		for (i = s; i < parts[powerPartsIndex].pinCount; i++) {
			//動力円盤、動力ロッドの場合
			if (s == 1) {
				srcX = rotateX(x, y, x+parts[powerPartsIndex].pinX[i], y+parts[powerPartsIndex].pinY[i], prevA);
				srcY = rotateY(x, y, x+parts[powerPartsIndex].pinX[i], y+parts[powerPartsIndex].pinY[i], prevA);
				disX = rotateX(x, y, x+parts[powerPartsIndex].pinX[i], y+parts[powerPartsIndex].pinY[i], angle);
				disY = rotateY(x, y, x+parts[powerPartsIndex].pinX[i], y+parts[powerPartsIndex].pinY[i], angle);

			//動力がピストンの場合
			} else {
				r = prevA;
				while (r > 360) { r = r - 360; }
				while (r < 0)   { r = r + 360; }
				if (r > 180) p = 360 - r; else p = r;

				srcX = rotateX(x, y, x+parts[powerPartsIndex].pinX[i]+p, y+parts[powerPartsIndex].pinY[i], angle);
				srcY = rotateY(x, y, x+parts[powerPartsIndex].pinX[i]+p, y+parts[powerPartsIndex].pinY[i], angle);

				r = parts[powerPartsIndex].r;
				while (r > 360) { r = r - 360; }
				while (r < 0)   { r = r + 360; }
				if (r > 180) p = 360 - r; else p = r;

				disX = rotateX(x, y, x+parts[powerPartsIndex].pinX[i]+p, y+parts[powerPartsIndex].pinY[i], angle);
				disY = rotateY(x, y, x+parts[powerPartsIndex].pinX[i]+p, y+parts[powerPartsIndex].pinY[i], angle);
			}

			//**************  Debug  ****************************************
			if (debugMode == true) {
				MessageString = langConvFormat('-- 動力部品のピン %1 の移動処理を開始 --', parts[powerPartsIndex].pinIndex[i], null, null, null);
				console.log(MessageString);
			}
			//**************  Debug  ****************************************
			
			//pc=パーツ数
			for (pc = 1; pc <= GetPartsNumberForPinIndex(powerPartsIndex, parts[powerPartsIndex].pinIndex[i], 0); pc++) {
				
				
				//---------------------------------------------------------------
				//部品情報のＰＵＳＨ（partsP ← parts）
				//---------------------------------------------------------------
				pushPartsArr(partsP);

				//**************  Debug  ****************************************
				if (debugMode == true) {
					MessageString = Format("call CanMove(%1, %2,  %3, %4, %5, %6, %7, 1);", powerPartsIndex, parts[powerPartsIndex].pinIndex[i], pc, srcX, srcY, disX, disY, null);
					console.log(MessageString);
				}
				//**************  Debug  ****************************************
				//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
				res = CanMove(powerPartsIndex, parts[powerPartsIndex].pinIndex[i], pc, srcX, srcY, disX, disY, 1);
				//---------------------------------------------------------------
				//res
				// 0:エラーなし
				// 1:位置が確定できない部品があるため移動できません。
				// 2:固定ピンの影響で移動できません。
				// 3:ロッドの長さが合わないので移動できません。
				// 4:（動かしてみたがだめ）
				// 5:ロッドの長さが合わないので移動できません。
				// 6:ロッドの長さが合わないので移動できません。
				// 7:ロッドの長さが合わないので移動できません。
				// 8:（動かしてみたがだめ）
				// 9:（動かしてみたがだめ）
				//10:複雑すぎて移動できません。
				//---------------------------------------------------------------
				switch (res) {
					//移動成功
					case 0:
						//**************  Debug  **************************************
						if (debugMode == true) {
							MessageString = langConvFormat("-- 動力部品のピン %1 の移動処理を完了 --", parts[powerPartsIndex].pinIndex[i], null, null, null);
							console.log(MessageString);
						}
						//**************  Debug  **************************************
						
						CanMoveFlagT++;
						CanMoveFlagF = 0;
						ErrorCount = 0;
						break;

					//移動失敗（順序を変えて再挑戦）
					case 1:
					case 10:
						//---------------------------------------------------------------
						//部品情報のＰＯＰ（parts ← partsP）
						//---------------------------------------------------------------
						popPartsArr(partsP);

						CanMoveFlagF++;
						break;

					//移動不可能（ピストンの場合は、再試行）
					case 3:
					case 5:
					case 6:
					case 7:
						//動力円盤、動力ロッドの場合
						if (s == 1) {
							//**************  Debug  ************************************
							if (debugMode == true) {
								MessageString = langConvFormat("== 動力部品の移動処理終了（動力部品のピン %1 は移動できない） ==", parts[powerPartsIndex].pinIndex[i], null, null, null);
								console.log(MessageString);
								console.log(' ');
							}
							//**************  Debug  ************************************

							//-----------------------------------------------------------
							//移動ができなかった場合は、トラックバーを戻して終了
							//-----------------------------------------------------------
							MyMessageDlg(0, langConv("エラー"), CanMoveResultMessage, null);		//CanMoveResultMessageは、CanMove()で設定
							document.getElementById("trackBar").value = prevTrackBarPosition;
							document.getElementById("stop").checked = true;
							//---------------------------------------------------------------
							//部品情報をテンポラリから復帰（parts ← partsT）
							//---------------------------------------------------------------
							popPartsArr(partsT);

							//再描画
							redrawCanvas();

							return res;
						}

						//-----------------------------------------------------------
						//動力ピストンの場合（移動量を変えて再試行）
						//-----------------------------------------------------------
						//移動量を変えても移動できなかった場合は、トラックバーを戻して終了
						if (ErrorCount > Math.round(360 / sp)) {
							//**************  Debug  ************************************
							if (debugMode == true) {
								MessageString = langConvFormat("== 動力部品の移動処理終了（動力部品のピン %1 は移動できない） ==", parts[powerPartsIndex].pinIndex[i], null, null, null);
								console.log(MessageString);
								console.log(' ');
							}
							//**************  Debug  ************************************

							MyMessageDlg(0, langConv("エラー"), CanMoveResultMessage, null);		//CanMoveResultMessageは、CanMove()で設定
							document.getElementById("trackBar").value = prevTrackBarPosition;
							document.getElementById("stop").checked = true;
							//---------------------------------------------------------------
							//部品情報をテンポラリから復帰（parts ← partsT）
							//---------------------------------------------------------------
							popPartsArr(partsT);

							//再描画
							redrawCanvas();

							return res;
						}
	                    //移動量を変えて再試行
	                    ErrorCount++;
						parts[powerPartsIndex].r = parts[powerPartsIndex].r + sp;

						while (parts[powerPartsIndex].r > 360) {
							parts[powerPartsIndex].r = parts[powerPartsIndex].r - 360;
						}
						//---------------------------------------------------------------
						//部品情報のＰＯＰ（parts ← partsP）
						//---------------------------------------------------------------
						popPartsArr(partsP);

						CanMoveFlagT = 0;
						CanMoveFlagF = 0;
						break;

					//移動不可能
					case 2:
					case 4:
					case 8:
					case 9:
						//**************  Debug  ************************************
						if (debugMode == true) {
							MessageString = langConvFormat("== 動力部品の移動処理終了（動力部品のピン %1 は移動できない） ==", parts[powerPartsIndex].pinIndex[i], null, null, null);
							console.log(MessageString);
							console.log(' ');
						}
						//**************  Debug  ************************************

						//-----------------------------------------------------------
						//移動ができなかった場合は、トラックバーを戻して終了
						//-----------------------------------------------------------
						MyMessageDlg(0, langConv("エラー"), CanMoveResultMessage, null);		//CanMoveResultMessageは、CanMove()で設定
						document.getElementById("trackBar").value = prevTrackBarPosition;
						document.getElementById("stop").checked = true;
						//---------------------------------------------------------------
						//部品情報をテンポラリから復帰（parts ← partsT）
						//---------------------------------------------------------------
						popPartsArr(partsT);

						//再描画
						redrawCanvas();

						return res;
						break;
				}
			}
		}
	}

	//**************  Debug  ********************************************
	if (debugMode == true) {
		MessageString = langConv("== 移動し残した部品の有無を調べる。 ==");
		console.log(MessageString);
	}
	//**************  Debug  ********************************************

	//-------------------------------------------------------------------
	//移動していない部品の有無の検査
	//-------------------------------------------------------------------
	for (i = 0; i < partsCount; i++) {
		if (parts[i].moveFlag == 0) {
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("== 動力部品の移動処理終了（部品 %1 は移動していない） ==", i, null, null, null);
				console.log(MessageString);
				console.log(' ');
			}
			//**************  Debug  ************************************

			MyMessageDlg(0, langConv("エラー"), langConv('移動できません。'), null);
			document.getElementById("trackBar").value = prevTrackBarPosition;
			document.getElementById("stop").checked = true;
			
			//-------------------------------------------------------------
			//部品情報をテンポラリから復帰（parts ← partsT）
			//-------------------------------------------------------------
			popPartsArr(partsT);

			//再描画
			redrawCanvas();

			return 11;
		}
	}

	//**************  Debug  ********************************************
	if (debugMode == true) {
		MessageString = langConv("== 動力部品の移動処理終了（すべての部品が移動している） ==");
		console.log(MessageString);
		console.log(' ');
	}
	//**************  Debug  ********************************************

	//すべての部品についての処理
	for (i = 0; i < partsCount; i++) {
		partsT[i].x = parts[i].x;
		partsT[i].y = parts[i].y;
		partsT[i].a = parts[i].a;
		partsT[i].r = parts[i].r;
	}
	//-------------------------------------------------------------
	//部品情報をテンポラリから復帰（parts ← partsT）
	//-------------------------------------------------------------
	popPartsArr(partsT);

	//ペン位置をリストに取得
	GetPenPosition();
	//再描画
	redrawCanvas();
	//トラックバーの位置を保存
	prevTrackBarPosition = TrackBarPosition;
	
	return 0;
}

//-----------------------------------------------------------
//  指定した部品の指定したピンが指定した場所に移動できるか　否か？
//-----------------------------------------------------------
function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {

	var i, j, k, l, r;

	var no1, no2;
	var pno1, pno2;
	var pnoc1, pnoc2;
	var cnt;

	var xD1, yD1;
	var xD2, yD2;

	var x1, y1, r1, x2, y2, r2;

	var Pos2;							//: TPointD;
	var PosCross;						//: TPointD;
	var PosCross2;					//: TMathResult;

	var xCross, yCross;

	var a1, a2, ad1, ad2;
	var a01, a02;
	var aCross1, aCross2;
	var xDM, yDM;

	var aa, bb, cc, dd;
	var fa;

	var tX, tY, tA;

	var tPos;							//: TPointD;

	var p1;
	var ppos;							//: TPointD;

	var x, y, angle;
	var xB1, yB1, angleB1, rB1;
	var xB2, yB2, angleB2, rB2;
	var srcX2, srcY2, disX2, disY2;

	var strTab, ttt;

	var res, ii;

	var partsP = [];					//: array[0..MaxParts] of TParts;

	var CanMoveFlagT;
	var CanMoveFlagF;

	var rr, p;

	var pc;

	var Rodlen;

	var result = 0;                    //エラーなし

	//**************  Debug  ********************************************
	if (debugMode == true) {
		Level = Level + 1;
		strTab = '                                                                    '.substr(0, (Level-1)*2+3);
	}
	//**************  Debug  ********************************************

	//===================================================================
	//対象のピンに接続されている部品の部品番号の取得
	//===================================================================
	no1 = GetPartsNumberForPinIndex(PartsNo, PinIndex, PartsCount);

	//**************  Debug  ********************************************
	if (debugMode == true) {
		MessageString = langConvFormat("１つ目の部品の部品番号の取得 ⇒ 部品 %1", no1, null, null, null);
		console.log(strTab + MessageString);
	}
	//**************  Debug  ********************************************

	//===================================================================
	//自由度を求める
	//===================================================================
	while (SetFreeLevel() == false);

	//===================================================================
	//次に接続されている部品がない場合
	//    接続部品がないのにピンが配置できるので、対象のピンは固定ピンである
	//===================================================================
	if (no1 == -1) {
		//**************  Debug  ****************************************
		if (debugMode == true) {
			MessageString = '接続部品はない。（対象のピンは固定ピン）';
			console.log(strTab + MessageString);
			Level = Level - 1;
		}
		//**************  Debug  ****************************************

		return 0;          //エラーなし
	}

	//===================================================================
	//次の部品が移動済みの場合
	//===================================================================
	if (parts[no1].moveFlag == 1) {
		//**************  Debug  ****************************************
		if (debugMode == true) {
			MessageString = langConvFormat("１つ目の部品 %1 (%2) は移動済み。", no1, parts[no1].kind, null, null);
			console.log(strTab + MessageString);
			Level = Level - 1;
		}
		//**************  Debug  ****************************************

		return 0;          //エラーなし
	}
	//===================================================================
	//次の部品に固定ピンがある（移動できない）
	//===================================================================
	for (i = 0; i < parts[no1].pinCount; i++) {
		if (parts[no1].pinType[i] == 1 && parts[no1].pinIndex[i] != PinIndex) {
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("１つ目の部品 %1 に固定ピン（Pin Index=%2）があるので移動できない。", no1, parts[no1].pinIndex[i], null, null);
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			CanMoveResultMessage = langConv("固定ピンの影響で移動できません。");
			return 2;
		}
	}

	//===================================================================
	//次の部品に仮固定ピンがある（移動する）
	//===================================================================
	for (i = 0; i < parts[no1].pinCount; i++) {
		if (parts[no1].pinType[i] == 2 && parts[no1].pinIndex[i] != PinIndex) {
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("１つ目の部品 %1 に仮固定ピンがある場合の処理。", no1, null, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ************************************

			//-----------------------------------
			//pnoc1 => no1の回転中心のピン番号（移動前）
			//---------------------------------------------------------------
			pnoc1 = GetPinNumberT(no1, srcX, srcY);

			//-----------------------------------------------------------
			//部品番号 no1
			//１つ目のピンのPinIndex番号 PinIndex
			//１つ目のピンの移動後の位置 (disX, disY)
			//２つ目のピンのPin番号 i
			//２つ目のピンの移動後の位置 部品no1のピン番号iと同一のPinIndexの固定ピンの座標
			//-----------------------------------------------------------

			//-----------------------------------------------------------
			//(x1, y1) => no1の回転中心座標（移動後）
			//-----------------------------------------------------------
			x1 = disX;
			y1 = disY;
			pno1 = i;

			//-----------------------------------------------------------
			//２つ目のピンの移動後の位置
			//-----------------------------------------------------------
			Pos2 = new GetPinPositionForPinIndex(parts[no1].pinIndex[i], 1);
			xCross = Pos2.x;
			yCross = Pos2.y;

			//-----------------------------------------------------------
			//no1の回転角度の補正（実際に動かしてみて、交点座標に来るか否か）
			//-----------------------------------------------------------
			for (j = 0; j <= 1; j++) {

				fa = RadToDeg(Math.atan2(parts[no1].pinY[pno1]-parts[no1].pinY[pnoc1], parts[no1].pinX[pno1]-parts[no1].pinX[pnoc1]));
				
				aCross1 = RadToDeg(Math.atan2((yCross - y1), (xCross - x1))) - fa + 180 * j;

				tX = parts[no1].x;
				tY = parts[no1].y;
				tA = parts[no1].a;

				//-------------------------------------------------------
				//no1の回転移動
				//-------------------------------------------------------
				xDM = rotateX(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);
				yDM = rotateY(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);

				parts[no1].x = xDM;
				parts[no1].y = yDM;
				parts[no1].a = aCross1;

				tPos = new GetPinPositionForPinNumber(no1, pno1);

				parts[no1].x = tX;
				parts[no1].y = tY;
				parts[no1].a = tA;

				if (CmpPosition(tPos.x, tPos.y, xCross, yCross) == true) {
					break;
				}
				
				if (j == 0) {
					continue;
				}

				//-------------------------------------------------------
				//交点に来ない場合は、終了
				//-------------------------------------------------------
				//**************  Debug  ********************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 が仮固定位置に来ないので移動できない。", no1, null, null, null);
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ********************************

				CanMoveResultMessage = langConv("ロッドの長さが合わないので移動できません。");
				return 3;
			}


			//===========================================================
			//移動前の処理
			//===========================================================
			//-----------------------------------------------------------
			//移動が確定したピン（他部品のピンを含む）を固定ピンにする
			//-----------------------------------------------------------
			parts[no1].moveFlag = MoveFlag;

			if (MoveFlag == 1) {
				//-------------------------------------------------------
				//no1 のすべてのピンと同一のPinIndexのピン（稼動ピン）をすべて仮固定ピンとする
				//-------------------------------------------------------
				ttt = '';
				for (j = 0; j < parts[no1].pinCount; j++) {
					for (k = 0; k < partsCount; k++) {
						for (l = 0; l < parts[k].pinCount; l++) {
							if (parts[k].pinIndex[l] == parts[no1].pinIndex[j] && parts[k].pinType[l] == 0) {
								parts[k].pinType[l] = 2;
								ttt = ttt + parts[k].pinIndex[l] + ' ';
							}
						}
					}
				}
				//**************  Debug  ********************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 のピン %2 を仮固定ピンとする。", no1, ttt, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ********************************


				//-------------------------------------------------------
				//no1 のすべてのピンを固定ピンとする
				//-------------------------------------------------------
				ttt = '';
				for (j = 0; j < parts[no1].pinCount; j++) {
					parts[no1].pinType[j] = 1;
					ttt = ttt + parts[no1].pinIndex[j] + ' ';
				}
				//**************  Debug  ********************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 のピン %2 を固定ピンとする。", no1, ttt, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ********************************
			}

			//===========================================================
			//実際の移動処理
			//===========================================================
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 の移動。", no1, null, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ************************************

			//-----------------------------------------------------------
			//no1の回転移動
			//-----------------------------------------------------------

			//-----------------------------------------------------------
			//移動前の部品の位置の保存（no1）
			//-----------------------------------------------------------
			xB1 = parts[no1].x;
			yB1 = parts[no1].y;
			angleB1 = parts[no1].a;

			//-----------------------------------------------------------
			//no1の回転移動
			//-----------------------------------------------------------
			xDM = rotateX(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);
			yDM = rotateY(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);

			parts[no1].x = xDM;
			parts[no1].y = yDM;
			parts[no1].a = aCross1;
			parts[no1].moveFlag = MoveFlag;

			//-----------------------------------------------------------
			//no1のすべての接続部品についての処理
			//-----------------------------------------------------------
			CanMoveFlagT = 0;
			CanMoveFlagF = 0;

			while (CanMoveFlagT + CanMoveFlagF < parts[no1].pinCount-1) {
			
				for (j = 0; j < parts[no1].pinCount; j++) {

					//**************  Debug  ********************************
					if (debugMode == true) {
						MessageString = langConvFormat("●部品 %1 のピン %2 への接続部品の処理。", no1, parts[no1].pinIndex[j], null, null);
						console.log(strTab + MessageString);
					}
					//**************  Debug  ********************************

					x = xB1;
					y = yB1;
					angle = angleB1;

					srcX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
					srcY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

					x = parts[no1].x;
					y = parts[no1].y;
					angle = parts[no1].a;

					disX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
					disY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

					//-------------------------------------------------------
					//移動ができなかった場合は、終了
					//-------------------------------------------------------
					if (partsT[no1].pinType[j] == 0 && no1 != powerPartsIndex) {

						for (pc = 1; pc <= GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[j], 0); pc++) {
							//---------------------------------------------------------------
							//部品情報のＰＵＳＨ（partsP ← parts）
							//---------------------------------------------------------------
							pushPartsArr(partsP);

							//**************  Debug  ****************************************
							if (debugMode == true) {
								MessageString = Format("call CanMove(%1, %2, %3, %4, %5,%6, %7, %8);", no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX, disY, MoveFlag);
								console.log(strTab + MessageString);
							}
							//**************  Debug  ****************************************
							//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
							res = CanMove(no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, 1);
							//---------------------------------------------------------------
							//res
							// 0:エラーなし
							// 1:位置が確定できない部品があるため移動できません。
							// 2:固定ピンの影響で移動できません。
							// 3:ロッドの長さが合わないので移動できません。
							// 4:（動かしてみたがだめ）
							// 5:ロッドの長さが合わないので移動できません。
							// 6:ロッドの長さが合わないので移動できません。
							// 7:ロッドの長さが合わないので移動できません。
							// 8:（動かしてみたがだめ）
							// 9:（動かしてみたがだめ）
							//10:複雑すぎて移動できません。
							//---------------------------------------------------------------
							switch (res) {
								//移動成功
								case 0:
									CanMoveFlagT++;
									CanMoveFlagF = 0;
									break;
								
								//移動失敗（順序を変えて再挑戦）
								case 1:
								case 10:
									//---------------------------------------------------------------
									//部品情報のＰＯＰ（parts ← partsP）
									//---------------------------------------------------------------
									popPartsArr(partsP);

									CanMoveFlagF++;
									result = res;
									break;
								
								//移動不可能
								case 2:
								case 3:
								case 4:
								case 5:
								case 6:
								case 7:
								case 8:
								case 9:
									//**************  Debug  ************************************
									if (debugMode == true) {
										MessageString = langConv("移動不能");
										console.log(strTab + MessageString);
										Level = Level - 1;
									}
									//**************  Debug  ************************************

									return res;
							}
						}
					}
				}
			}

			if (CanMoveFlagF == 0) {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConv("移動完了");
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ************************************

				return 0;
			} else {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConv("移動不能");
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ************************************

				return 11;
			}
		}
	}

	//===================================================================
	//次の部品がスライドロッドの場合
	//CanMove(PartsNo, PinIndex, PartsCount: Integer; srcX, srcY, disX, disY: Double; MoveFlag: Integer): Integer;
	//===================================================================
	if (parts[no1].kind == "rodSlide1" || parts[no1].kind == "rodSlide2") {
		if (parts[no1].kind == "rodSlide2") {
			Rodlen = 340;
		} else {
			Rodlen = 180;
		}

		//**************  Debug  ************************************
		if (debugMode == true) {
			MessageString = langConvFormat("１つ目の部品 %1 がスライドロッドの場合の処理。", no1, null, null, null);
			console.log(strTab + MessageString);
		}
		//**************  Debug  ************************************

		//スライド基点の座標（移動前後で同一の座標）
		x1 = rotateX(parts[no1].x, parts[no1].y, parts[no1].x + parts[no1].r, parts[no1].y, parts[no1].a);
		y1 = rotateY(parts[no1].x, parts[no1].y, parts[no1].x + parts[no1].r, parts[no1].y, parts[no1].a);

		//移動後のピン座標とスライド基点との距離の算出
		aa = Math.sqrt((disX - x1)**2 + (disY - y1)**2);

		//移動前のピン座標とスライドロッドパーツの原点との距離の算出（この距離は移動前後で変わらない）
		bb = Math.sqrt((srcX - partsT[no1].x)**2 + (srcY - partsT[no1].y)**2);

		//スライド基点が移動可能範囲か否かの判定
		if (bb < 60) {
			//ピンがスリットのパーツ原点側にある場合
			if (aa+bb < 60 || (aa+bb) > Rodlen) {
				//移動が不可能な場合
				//**************  Debug  ****************************************
				if (debugMode == true) {
					MessageString = langConv("スライドロッドの長さが合わないので移動できない。")
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ****************************************

				CanMoveResultMessage = langConv("スライドロッドの長さが合わないので移動できません。");
				return 3;
			}
		} else {
			//ピンがスリットのパーツ原点の反対側にある場合
			if (bb-aa < 60 || (bb-aa) > Rodlen) {
				//移動が不可能な場合
				//**************  Debug  ****************************************
				if (debugMode == true) {
					MessageString = langConv("スライドロッドの長さが合わないので移動できない。");
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ****************************************

				CanMoveResultMessage = langConv("スライドロッドの長さが合わないので移動できません。");
				return 3;
			}
		}

		//------------------------------------------------------------------------
		//移動可能な場合の処理
		//------------------------------------------------------------------------
		parts[no1].moveFlag = MoveFlag;

		if (MoveFlag == 1) {
			//-------------------------------------------------------
			//no1 のすべてのピンと同一のPinIndexのピン（稼動ピン）をすべて仮固定ピンとする
			//-------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no1].pinCount; j++) {
				for (k = 0; k < partsCount; k++) {
					for (l = 0; l < parts[k].pinCount; l++) {
						if (parts[k].pinIndex[l] == parts[no1].pinIndex[j] && parts[k].pinType[l] == 0) {
							parts[k].pinType[l] = 2;
							ttt = ttt + parts[k].pinIndex[l] + ' ';
						}
					}
				}
			}

			//**************  Debug  ********************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を仮固定ピンとする。", no1, ttt, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ********************************

			//-------------------------------------------------------
			//no1 のすべてのピンを固定ピンとする
			//-------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no1].pinCount; j++) {
				parts[no1].pinType[j] = 1;
				ttt = ttt + parts[no1].pinIndex[j] + ' ';
			}

			//**************  Debug  ********************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を固定ピンとする。", no1, ttt, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ********************************
		}

		//===========================================================
		//実際の移動処理
		//===========================================================

		//**************  Debug  ************************************
		if (debugMode == true) {
			MessageString = langConvFormat("部品 %1 の移動。", no1, null, null, null);
			console.log(strTab + MessageString);
		}
		//**************  Debug  ************************************

		//移動後のパーツの角度(cc)を求める
		if (bb < 60) {
			cc = RadToDeg(Math.atan2((disY - y1), (disX - x1))) + 180;
		} else {
			cc = RadToDeg(Math.atan2((disY - y1), (disX - x1))) + 360;
		}
		
		while (cc >= 360) {
			cc = cc - 360;
		}
		
		//パーツ原点とスライド基点との距離(dd)を求める
		if (bb < 60) {
			dd = aa + bb
		} else {
			dd = bb - aa;
		}

		//移動後のパーツの原点を求める
		x2 = x1 + (dd * Math.cos(DegToRad(cc)));
		y2 = y1 + (dd * Math.sin(DegToRad(cc)));

		x2 = disX - (bb * Math.cos(DegToRad(cc)));
		y2 = disY - (bb * Math.sin(DegToRad(cc)));

		//-----------------------------------------------------------
		//移動前の部品の位置の保存（no1）
		//-----------------------------------------------------------
		xB1 = parts[no1].x
		yB1 = parts[no1].y;
		angleB1 = parts[no1].a;
		rB1 = parts[no1].r;

		//-----------------------------------------------------------
		//no1のピストン移動
		//-----------------------------------------------------------
		parts[no1].x = x2;
		parts[no1].y = y2;
		parts[no1].a = cc;
		parts[no1].r = dd;
		parts[no1].moveFlag = MoveFlag;

		//-----------------------------------------------------------
		//no1のすべての接続部品についての処理
		//-----------------------------------------------------------
		CanMoveFlagT = 0;
		CanMoveFlagF = 0;

		while (CanMoveFlagT + CanMoveFlagF < parts[no1].pinCount-1) {
			for (j = 0; j < parts[no1].pinCount; j++) {

				//**************  Debug  ********************************
				if (debugMode == true) {
					MessageString = langConvFormat("●部品 %1 のピン %2 に接続されている部品の処理。", no1, parts[no1].pinIndex[j], null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ********************************

				x = xB1;
				y = yB1;
				angle = angleB1;

				srcX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
				srcY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

				x = parts[no1].x;
				y = parts[no1].y;
				angle = parts[no1].a;

				disX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
				disY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

				//-------------------------------------------------------
				//移動ができなかった場合は、終了
				//-------------------------------------------------------
				if (partsT[no1].pinType[j] == 0 && no1 != powerPartsIndex) {
					for (pc = 1; pc <= GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[j], 0); pc++) {
						//---------------------------------------------------------------
						//部品情報のＰＵＳＨ（partsP ← parts）
						//---------------------------------------------------------------
						pushPartsArr(partsP);

						//**************  Debug  ****************************************
						if (debugMode == true) {
							MessageString = Format("call CanMove(%1, %2, %3, %4, %5, %6, %7, %8);", no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, MoveFlag);
							console.log(strTab + MessageString);
						}
						//**************  Debug  ****************************************
						//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
						res = CanMove(no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, 1);
						//---------------------------------------------------------------
						//res
						// 0:エラーなし
						// 1:位置が確定できない部品があるため移動できません。
						// 2:固定ピンの影響で移動できません。
						// 3:ロッドの長さが合わないので移動できません。
						// 4:（動かしてみたがだめ）
						// 5:ロッドの長さが合わないので移動できません。
						// 6:ロッドの長さが合わないので移動できません。
						// 7:ロッドの長さが合わないので移動できません。
						// 8:（動かしてみたがだめ）
						// 9:（動かしてみたがだめ）
						//10:複雑すぎて移動できません。
						//---------------------------------------------------------------
						switch (res) {
							//移動成功
                        	case 0:
								CanMoveFlagT++;
								CanMoveFlagF = 0;
								break;
							
							//移動失敗（順序を変えて再挑戦）
							case 1:
							case 10:
								//---------------------------------------------------------------
								//部品情報のＰＯＰ（parts ← partsP）
								//---------------------------------------------------------------
								popPartsArr(partsP);

								CanMoveFlagF++;
								result = res;
								break;
							
							//移動不可能
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:
								//**************  Debug  ************************************
								if (debugMode == true) {
									MessageString = langConv("移動不能");
									console.log(strTab + MessageString);
									Level = Level - 1;
								}
								//**************  Debug  ************************************

								return res;
						}
					}
				}
			}
		}

		if (CanMoveFlagF == 0) {
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConv("移動完了");
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			return 0;

		} else {
			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConv("移動不能");
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			return reslt;
		}
	}













	//===================================================================
	//次の部品が動力なしのピストンの場合
	//===================================================================
	if (parts[no1].kind == "piston1" || parts[no1].kind == "piston2") {

		//**************  Debug  ************************************
		if (debugMode == true) {
			MessageString = langConvFormat("１つ目の部品 %1 が動力なしのピストンの場合の処理。", no1, null, null, null);
			console.log(strTab + MessageString);
		}
		//**************  Debug  ************************************

		if (parts[no1].a == RadToDeg(Math.atan2((disY - parts[no1].y), (disX - parts[no1].x)))) {
			aa = Math.sqrt((disX - parts[no1].x)**2 + (disY - parts[no1].y)**2) - parts[no1].pinX[GetPinNumberForPinIndex(PartsNo, PinIndex)];

			if (aa >= -1 && aa <= 181) {
				//移動可能な場合
				parts[no1].moveFlag = MoveFlag;

				if (MoveFlag == 1) {
					//-------------------------------------------------------
					//no1 のすべてのピンと同一のPinIndexのピン（稼動ピン）をすべて仮固定ピンとする
					//-------------------------------------------------------
					ttt = '';
					for (j = 0; j < parts[no1].pinCount; j++) {
						for (k = 0; k < partsCount; k++) {
							for (l = 0; l < parts[k].pinCount; l++) {
								if (parts[k].pinIndex[l] == parts[no1].pinIndex[j] && parts[k].pinType[l] == 0) {
									parts[k].pinType[l] = 2;
									ttt = ttt + parts[k].pinIndex[l] + ' ';
								}
							}
						}
					}

					//**************  Debug  ********************************
					if (debugMode == true) {
						MessageString = langConvFormat("部品 %1 のピン %2 を仮固定ピンとする。", no1, ttt, null, null);
						console.log(strTab + MessageString);
					}
					//**************  Debug  ********************************

					//-------------------------------------------------------
					//no1 のすべてのピンを固定ピンとする
					//-------------------------------------------------------
					ttt = '';
					for (j = 0; j < parts[no1].pinCount; j++) {
						parts[no1].pinType[j] = 1;
						ttt = ttt + parts[no1].pinIndex[j] + ' ';
					}

					//**************  Debug  ********************************
					if (debugMode == true) {
						MessageString = langConvFormat("部品 %1 のピン %2 を固定ピンとする。", no1, ttt, null, null);
						console.log(strTab + MessageString);
					}
					//**************  Debug  ********************************
				}

				//===========================================================
				//実際の移動処理
				//===========================================================

				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 の移動", no1, null, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************

				//-----------------------------------------------------------
				//no1のピストン移動
				//-----------------------------------------------------------
				//-----------------------------------------------------------
				//移動前の部品の位置の保存（no1）
				//-----------------------------------------------------------
				xB1 = parts[no1].x;
				yB1 = parts[no1].y;
				angleB1 = parts[no1].a;
				rB1 = parts[no1].r;

				//-----------------------------------------------------------
				//no1のピストン移動
				//-----------------------------------------------------------
				parts[no1].r = aa;
				parts[no1].moveFlag = MoveFlag;

				//-----------------------------------------------------------
				//no1のすべての接続部品についての処理
				//-----------------------------------------------------------
				CanMoveFlagT = 0;
				CanMoveFlagF = 0;

				while (CanMoveFlagT + CanMoveFlagF < parts[no1].pinCount-1) {
					for (j = 0; j < parts[no1].pinCount; j++) {

						//**************  Debug  ********************************
						if (debugMode == true) {
							MessageString = langConvFormat("●部品 %1 のピン %2 に接続されている部品の処理。", no1, parts[no1].pinIndex[j], null, null);
							console.log(strTab + MessageString);
						}
						//**************  Debug  ********************************

						x = xB1;
						y = yB1;
						angle = angleB1;
						rr = rB1;

						while (rr > 360) {
							rr = rr - 360;
						}
						while (rr < 0) {
							rr = rr + 360;
						}
						if (rr > 180) {
							p = 360 - rr;
						} else {
							p = rr;
						}

						srcX2 = rotateX(x, y, x+parts[no1].pinX[j]+p, y+parts[no1].pinY[j], angle);
						srcY2 = rotateY(x, y, x+parts[no1].pinX[j]+p, y+parts[no1].pinY[j], angle);

						x = parts[no1].x;
						y = parts[no1].y;
						angle = parts[no1].a;
						rr = parts[no1].r;

						while (rr > 360) {
							rr = rr - 360;
						}
						while (rr < 0) {
							rr = rr + 360;
						}
						if (rr > 180) {
							p = 360 - rr;
						} else {
							p = rr;
						}

						disX2 = rotateX(x, y, x+parts[no1].pinX[j]+p, y+parts[no1].pinY[j], angle);
						disY2 = rotateY(x, y, x+parts[no1].pinX[j]+p, y+parts[no1].pinY[j], angle);

						//-------------------------------------------------------
						//移動ができなかった場合は、終了
						//-------------------------------------------------------
						if (partsT[no1].pinType[j] == 0 && no1 != powerPartsIndex) {
							for (pc = 1; pc <= GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[j], 0); pc++) {
								//---------------------------------------------------------------
								//部品情報のＰＵＳＨ（partsP ← parts）
								//---------------------------------------------------------------
								pushPartsArr(partsP);

								//**************  Debug  ****************************************
								if (debugMode == true) {
									MessageString = Format("call CanMove(%1, %2, %3, %4, %5, %6, %7, 1);", no1 ,parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, null);
									console.log(strTab + MessageString);
								}
								//**************  Debug  ****************************************
								//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
								res = CanMove(no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, 1);
								//---------------------------------------------------------------
								// 0:エラーなし
								// 1:位置が確定できない部品があるため移動できません。
								// 2:固定ピンの影響で移動できません。
								// 3:ロッドの長さが合わないので移動できません。
								// 4:（動かしてみたがだめ）
								// 5:ロッドの長さが合わないので移動できません。
								// 6:ロッドの長さが合わないので移動できません。
								// 7:ロッドの長さが合わないので移動できません。
								// 8:（動かしてみたがだめ）
								// 9:（動かしてみたがだめ）
								//10:複雑すぎて移動できません。
								//---------------------------------------------------------------

								switch (res) {
									//移動成功
									case 0:
										CanMoveFlagT++;
										CanMoveFlagF = 0;
										break;
									
									//移動失敗（順序を変えて再挑戦）
									case 1:
									case 10:
										//---------------------------------------------------------------
										//部品情報のＰＯＰ（parts ← partsP）
										//---------------------------------------------------------------
										popPartsArr(partsP);

										CanMoveFlagF++;
										result = res;
										break;
									
									//移動不可能
									case 2:
									case 3:
									case 4:
									case 5:
									case 6:
									case 7:
									case 8:
									case 9:

										//**************  Debug  ************************************
										if (debugMode == true) {
											MessageString = langConv("移動不能");
											console.log(strTab + MessageString);
											Level = Level - 1;
										}
										//**************  Debug  ************************************

										return res;
								}
							}
						}
					}
				}

				if (CanMoveFlagF == 0) {
					//**************  Debug  ************************************
					if (debugMode == true) {
						MessageString = langConv("移動完了");
						console.log(strTab + MessageString);
						Level = Level - 1;
					}
					//**************  Debug  ************************************

					return 0;

				} else {

					//**************  Debug  ************************************
					if (debugMode == true) {
						MessageString = langConv("移動不能");
						console.log(strTab + MessageString);
						Level = Level - 1;
					}
					//**************  Debug  ************************************

					return 11;
				}
			
			} else {
				//**************  Debug  ****************************************
				if (debugMode == true) {
					MessageString = langConv("ピストンロッドの長さが合わないので移動できない。");
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ****************************************

				CanMoveResultMessage = langConv("ピストンロッドの長さが合わないので移動できません。");
				return 3;
			}
		}
	}

	//===================================================================
	//次の次の部品がない場合は、位置が確定できない
	//===================================================================
	if (parts[no1].pinCount == 1) {
		//**************  Debug  ****************************************
		if (debugMode == true) {
			MessageString = langConv("２つ目の部品がないので移動できない。");
			console.log(strTab + MessageString);
			Level = Level - 1;
		}
		//**************  Debug  ****************************************

		CanMoveResultMessage = langConv("位置が確定できない部品があるため移動できません。");
		return 1;
	}

	//===================================================================
	//次の次の部品がある場合
	//===================================================================

	//**************  Debug  ********************************************
	if (debugMode == true) {
		MessageString = langConvFormat("１つ目の部品 %1 の %2 個のピンについての処理。", no1, parts[no1].pinCount, null, null);
		console.log(strTab + MessageString);
	}
	//**************  Debug  ********************************************

	//-------------------------------------------------------------------
	//次の次の部品についての処理（自由度１の部品）
	//-------------------------------------------------------------------
	for (var i = 0; i < parts[no1].pinCount; i++) {
		if (parts[no1].pinIndex[i] == PinIndex) continue;

		for (pc = 1; pc <= GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[i], 0); pc++) {

			no2 = GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[i], pc);
			
			//部品がない
			if (no2 == -1) continue;
			
			//**************  Debug  ****************************************
			if (debugMode == true) {
				MessageString = langConvFormat("２つ目の部品の部品番号の取得 ⇒ 部品 %1", no2, null, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ****************************************

			//元の部品
			if (no2 == PartsNo) {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("２つ目の部品の部品番号の取得 ⇒ 部品 %1 は、１つ前の部品なので、次の部品を検索。", no2, null, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************
				no2 = -1;
				continue;
			}
			
			//移動不可能
			if (parts[no2].freeLevel == 0) {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("２つ目の部品の部品番号の取得 ⇒ 部品 %1 は、移動が不可能なので、次の部品を検索。", no2, null, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************
				no2 = -1;
				continue;
			}
			//位置が不確定
			if (parts[no2].freeLevel == 2) {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("２つ目の部品の部品番号の取得 ⇒ 部品 %1 は、位置が不確定なので、次の部品を検索。", no2, null, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************
				res = 1;
				no2 = -1;
				continue;
			}
			//移動済み
			if (parts[no2].moveFlag == 1) {
				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("２つ目の部品の部品番号の取得 ⇒ 部品 %1 は、移動済みなので、次の部品を検索。", no2, null, null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************
				no2 = -1;
				continue;
			}
			
			break;
		}
		
		//次のピン
		if (no2 == -1) continue;

		//---------------------------------------------------------------
		//移動前の交点座標
		//---------------------------------------------------------------
		PosCross = new GetPinPositionForPinNumber(no1, i);

		//---------------------------------------------------------------
		//pno1 => 交点のno1のピン番号
		//---------------------------------------------------------------
		pno1 = i;

		//---------------------------------------------------------------
		//pno2 => 交点のno2のピン番号
		//---------------------------------------------------------------
		pno2 = GetPinNumberForPinIndex(no2, parts[no1].pinIndex[i]);

		//-----------------------------------
		//pnoc1 => no1の回転中心のピン番号（移動前）
		//---------------------------------------------------------------
		pnoc1 = GetPinNumberT(no1, srcX, srcY);

		//---------------------------------------------------------------
		//pnoc2 => no2の回転中心のピン番号（移動前）
		//---------------------------------------------------------------
		for (pnoc2 = 0; pnoc2 < parts[no2].pinCount; pnoc2++) {
			if (parts[no2].pinType[pnoc2] == 1 || parts[no2].pinType[pnoc2] == 2) {
				break;
			}
		}

		//---------------------------------------------------------------
		//(srcX, srcY) => no1の回転中心座標（移動前）
		// srcX
		// srcY
		//---------------------------------------------------------------
		//---------------------------------------------------------------
		//(Pos2.X, Pos2.Y) => no2の回転中心座標（移動前）
		//---------------------------------------------------------------
		Pos2 = new GetPinPositionForPinNumber(no2, pnoc2);

		//---------------------------------------------------------------
		//(x1, y1) => no1の回転中心座標（移動後）
		//---------------------------------------------------------------
		x1 = disX;
		y1 = disY;

		//---------------------------------------------------------------
		//(x2, y2) => no2の回転中心座標（移動後）
		//---------------------------------------------------------------
		if (parts[no2].pinType[pnoc2] == 1) {
			x2 = Pos2.x;
			y2 = Pos2.y;
		} else {
			var tmpPos = new GetPinPositionForPinIndex(parts[no2].pinIndex[pnoc2], 1);
			x2 = tmpPos.x;
			y2 = tmpPos.y;
		}

		//---------------------------------------------------------------
		//no1の回転半径
		//---------------------------------------------------------------
		r1 = Math.sqrt((srcX - PosCross.x)**2 + (srcY - PosCross.y)**2);

		//---------------------------------------------------------------
		//no2の回転半径
		//---------------------------------------------------------------
		r2 = Math.sqrt((Pos2.x - PosCross.x)**2 + (Pos2.y - PosCross.y)**2);

		//-----------------------------------
		//no1の移動前の角度（回転中心から見た角度）
		//---------------------------------------------------------------
		a01 = AdjustAngleForAngle(RadToDeg(Math.atan2((PosCross.y - srcY), (PosCross.x - srcX))));

		//---------------------------------------------------------------
		//no2の移動前の角度（回転中心から見た角度）
		//---------------------------------------------------------------
		a02 = AdjustAngleForAngle(RadToDeg(Math.atan2((PosCross.y - Pos2.y), (PosCross.x - Pos2.x))));

		//---------------------------------------------------------------
		//移動後の交点の座標
		//---------------------------------------------------------------
		//回転部品
		//if (parts[no2].kind < 90 then
		if (parts[no2].kind == "disk1Power" || parts[no2].kind == "disk2Power" || parts[no2].kind == "disk3Power" ||
			parts[no2].kind == "disk1" || parts[no2].kind == "disk2" || parts[no2].kind == "disk3" ||
			parts[no2].kind == "rod1Power" || parts[no2].kind == "rod2Power" ||
			parts[no2].kind == "rod1" || parts[no2].kind == "rod2" || parts[no2].kind == "rod3" || parts[no2].kind == "rod4" || parts[no2].kind == "rod5" || parts[no2].kind == "rod6" ||
			parts[no2].kind == "triangle1" || parts[no2].kind == "triangle2") {
			
			PosCross2 = new GetCircleToCircleCrossPoint(x1, y1, r1, x2, y2, r2);


		//ピストン、スライドロッド
		} else {
			PosCross2 = new GetCircleToLineCrossPoint(x1, y1, r1, parts[no2].x, parts[no2].y, parts[no2].a);
		}

		//移動できない
		if (PosCross2.ResultCode == 0) {

			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 と部品 %2 の交点がないので、移動できない。", no1, no2, null, null);
				console.log(strTab + MessageString);
				console.log(strTab + Format(" (x1=%1 y1=%2 r1=%3)", x1, y1, r1, null));
				console.log(strTab + Format(" (x2=%1 y2=%2 r2=%3)", x2, y2, r2, null));
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			CanMoveResultMessage = langConv("ロッドの長さが合わないので移動できません。");
			return 5;
		}

		//===============================================================
		//１箇所ないしは２箇所で接する場合
		//===============================================================
		//---------------------------------------------------------------
		//no1の角度変化の少ない方を採用
		//---------------------------------------------------------------

		a1 = RadToDeg(Math.atan2((PosCross2.y1 - disY), (PosCross2.x1 - disX)));
		a2 = RadToDeg(Math.atan2((PosCross2.y2 - disY), (PosCross2.x2 - disX)));
//		a1 = RadToDeg(Math.atan2((PosCross2.y1 - PosCross.y), (PosCross2.x1 - PosCross.x)));
//		a2 = RadToDeg(Math.atan2((PosCross2.y2 - PosCross.y), (PosCross2.x2 - PosCross.x)));

//		if (a1 < 0) a1 = a1 + 360;
//		if (a2 < 0) a2 = a2 + 360;

		ad1 = Math.abs(a1-a01);
		ad2 = Math.abs(a2-a01);


		if (ad1 > 180) ad1 = Math.abs(360-ad1);
		if (ad2 > 180) ad2 = Math.abs(360-ad2);

		//---------------------------------------------------------------
		//交点座標の移動量が小さい方を採用
		//---------------------------------------------------------------
/*
		ad1 = Math.sqrt((PosCross2.y1 - PosCross.y)**2 + (PosCross2.x1 - PosCross.x)**2);
		ad2 = Math.sqrt((PosCross2.y2 - PosCross.y)**2 + (PosCross2.x2 - PosCross.x)**2);
*/
		if (ad1 < ad2) {
			xCross = PosCross2.x1;
			yCross = PosCross2.y1;
		} else {
			xCross = PosCross2.x2;
			yCross = PosCross2.y2;
		}

		//---------------------------------------------------------------
		//no1の回転角度の補正（実際に動かしてみて、交点座標に来るか否か）
		//---------------------------------------------------------------
		for (j = 0; j <= 3; j++) {
			fa = RadToDeg(Math.atan2(parts[no1].pinY[pno1]-parts[no1].pinY[pnoc1], parts[no1].pinX[pno1]-parts[no1].pinX[pnoc1]));
			
			aCross1 = RadToDeg(Math.atan2((yCross - y1), (xCross - x1))) - fa + 180 * j;

			tX = parts[no1].x;
			tY = parts[no1].y
			tA = parts[no1].a;

			//no1の回転移動
			xDM = rotateX(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);
			yDM = rotateY(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);

			parts[no1].x = xDM;
			parts[no1].y = yDM;
			parts[no1].a = aCross1;

			tPos = new GetPinPositionForPinNumber(no1, pno1);

			parts[no1].x = tX;
			parts[no1].y = tY;
			parts[no1].a = tA;

			if (CmpPosition(tPos.x, tPos.y, xCross, yCross) == true) break;

			if (j == 0) continue;

			//交点に来ない場合は、終了

			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 と部品 %2 の交点がないので、移動できない。（no1）", no1, no2, null, null);
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			CanMoveResultMessage = langConv("ロッドの長さが合わないので移動できません。");
			return 6;
		}

		//---------------------------------------------------------------
		//no2の回転角度の補正（実際に動かしてみて、交点座標に来るか否か）
		//---------------------------------------------------------------
		//if (parts[no2].ShapeType < 90 then
		if (parts[no2].kind == "disk1Power" || parts[no2].kind == "disk2Power" || parts[no2].kind == "disk3Power" ||
			parts[no2].kind == "disk1" || parts[no2].kind == "disk2" || parts[no2].kind == "disk3" ||
			parts[no2].kind == "rod1Power" || parts[no2].kind == "rod2Power" ||
			parts[no2].kind == "rod1" || parts[no2].kind == "rod2" || parts[no2].kind == "rod3" || parts[no2].kind == "rod4" || parts[no2].kind == "rod5" || parts[no2].kind == "rod6" ||
			parts[no2].kind == "triangle1" || parts[no2].kind == "triangle2") {

			for (j = 0; j <= 3; j++) {
				fa = RadToDeg(Math.atan2(parts[no2].pinY[pno2]-parts[no2].pinY[pnoc2], parts[no2].pinX[pno2]-parts[no2].pinX[pnoc2]));
				aCross2 = RadToDeg(Math.atan2((yCross - y2), (xCross - x2))) - fa + 180 * j;

				tX = parts[no2].x;
				tY = parts[no2].y;
				tA = parts[no2].a;

				//no2の回転移動
				xDM = rotateX(x2, y2, parts[no2].x+(x2-Pos2.x), parts[no2].y+(y2-Pos2.y), aCross2 - parts[no2].a);
				yDM = rotateY(x2, y2, parts[no2].x+(x2-Pos2.x), parts[no2].y+(y2-Pos2.y), aCross2 - parts[no2].a);

				parts[no2].x = xDM;
				parts[no2].y = yDM;
				parts[no2].a = aCross2;

				tPos = new GetPinPositionForPinNumber(no2, pno2);

				parts[no2].x = tX;
				parts[no2].y = tY;
				parts[no2].a = tA;

				if (CmpPosition(tPos.x, tPos.y, xCross, yCross) == true) break;

				if (j == 0) continue;

				//交点に来ない場合は、終了

				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 と部品 %2 の交点がないので、移動できない（no2）", no1, no2, null, null);
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ************************************

				CanMoveResultMessage = langConv("ロッドの長さが合わないので移動できません。");
				return 7;
			}

		} else {

			aa = Math.sqrt((xCross - parts[no2].x)**2 + (yCross - parts[no2].y)**2) - parts[no2].pinX[pno2];

			if (aa <= -1 || aa >= 181) {
				//交点に来ない場合は、終了

				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("部品 %1 と部品 %2 の交点がないので、移動できない（no2）", no1, no2, null, null);
					console.log(strTab + MessageString);
					Level = Level - 1;
				}
				//**************  Debug  ************************************

				CanMoveResultMessage = langConv("ピストンロッドの長さが合わないので移動できません。");
				return 7;
			}
		}

		//===============================================================
		//移動前の処理
		//===============================================================
		//---------------------------------------------------------------
		//移動が確定したピン（他部品のピンを含む）を固定ピンにする
		//---------------------------------------------------------------
		parts[no1].moveFlag = MoveFlag;
		parts[no2].moveFlag = MoveFlag;

		if (MoveFlag == 1) {
			//-----------------------------------------------------------
			//no1 のすべてのピンと同一のPinIndexのピン（稼動ピン）をすべて仮固定ピンとする
			//-----------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no1].pinCount; j++) {
				for (k = 0; k < partsCount; k++) {
					for (l = 0; l < parts[k].pinCount; l++) {
						if (parts[k].pinIndex[l] == parts[no1].pinIndex[j] && parts[k].pinType[l] == 0) {
							parts[k].pinType[l] = 2;
							ttt = ttt + parts[k].pinIndex[l] + ' ';
						}
					}
				}
			}

			//**************  Debug  *************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を仮固定ピンとする。", no1, ttt, null, null);;
				console.log(strTab + MessageString);
			}
			//**************  Debug  *************************************

			//-----------------------------------------------------------
			//no2 のすべてのピンと同一のPinIndexのピン（稼動ピン）をすべて仮固定ピンとする
			//-----------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no2].pinCount; j++) {
				for (k = 0; k < partsCount; k++) {
					for (l = 0; l < parts[k].pinCount; l++) {
						if (parts[k].pinIndex[l] == parts[no2].pinIndex[j] && parts[k].pinType[l] == 0) {
							parts[k].pinType[l] = 2;
							ttt = ttt + parts[k].pinIndex[l] + ' ';
						}
					}
				}
			}

			//**************  Debug  *************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を仮固定ピンとする。", no2, ttt, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  *************************************


			//-----------------------------------------------------------
			//no1 のすべてのピンを固定ピンとする
			//-----------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no1].pinCount; j++) {
				parts[no1].pinType[j] = 1;
				ttt = ttt + parts[no1].pinIndex[j] + ' ';
			}

			//**************  Debug  *************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を固定ピンとする。", no1, ttt, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  *************************************

			//-----------------------------------------------------------
			//no2 のすべてのピンを固定ピンとする
			//-----------------------------------------------------------
			ttt = '';
			for (j = 0; j < parts[no2].pinCount; j++) {
				parts[no2].pinType[j] = 1;
				ttt = ttt + parts[no2].pinIndex[j] + ' ';
			}

			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConvFormat("部品 %1 のピン %2 を固定ピンとする。", no2, ttt, null, null);
				console.log(strTab + MessageString);
			}
			//**************  Debug  ************************************
		}

		//===============================================================
		//実際の移動処理
		//===============================================================

		//**************  Debug  ****************************************
		if (debugMode == true) {
			MessageString = langConvFormat("部品 %1 と部品 %2 の移動。", no1, no2, null, null);
			console.log(strTab + MessageString);
		}
		//**************  Debug  ****************************************

		//---------------------------------------------------------------
		//no1の回転移動
		//---------------------------------------------------------------
		//---------------------------------------------------------------
		//移動前の部品の位置の保存（no1）
		//---------------------------------------------------------------
		xB1 = parts[no1].x;
		yB1 = parts[no1].y;
		angleB1 = parts[no1].a;

		//---------------------------------------------------------------
		//no1の回転移動
		//---------------------------------------------------------------
		xDM = rotateX(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);
		yDM = rotateY(x1, y1, parts[no1].x + (disX - srcX), parts[no1].y + (disY - srcY), aCross1 - parts[no1].a);

		parts[no1].x = xDM;
		parts[no1].y = yDM;
		parts[no1].a = aCross1;
		parts[no1].moveFlag = MoveFlag;

		//---------------------------------------------------------------
		//no2の移動
		//---------------------------------------------------------------
		//---------------------------------------------------------------
		//移動前の部品の位置の保存（no2）
		//---------------------------------------------------------------
		xB2 = parts[no2].x;
		yB2 = parts[no2].y;
		angleB2 = parts[no2].a;
		rB2 = parts[no2].r;

		//---------------------------------------------------------------
		//no2の移動
		//---------------------------------------------------------------
		//if (PartsT[no2].ShapeType < 90 then
		if (parts[no2].kind == "disk1Power" || parts[no2].kind == "disk2Power" || parts[no2].kind == "disk3Power" ||
			parts[no2].kind == "disk1" || parts[no2].kind == "disk2" || parts[no2].kind == "disk3" ||
			parts[no2].kind == "rod1Power" || parts[no2].kind == "rod2Power" ||
			parts[no2].kind == "rod1" || parts[no2].kind == "rod2" || parts[no2].kind == "rod3" || parts[no2].kind == "rod4" || parts[no2].kind == "rod5" || parts[no2].kind == "rod6" ||
			parts[no2].kind == "triangle1" || parts[no2].kind == "triangle2") {

			xDM = rotateX(x2, y2, parts[no2].x+(x2-Pos2.x), parts[no2].y+(y2-Pos2.y), aCross2 - parts[no2].a);
			yDM = rotateY(x2, y2, parts[no2].x+(x2-Pos2.x), parts[no2].y+(y2-Pos2.y), aCross2 - parts[no2].a);

			parts[no2].x = xDM;
			parts[no2].y = yDM;
			parts[no2].a = aCross2;
			parts[no2].moveFlag = MoveFlag;
		
		} else {
			parts[no2].r = aa;
		}

		//---------------------------------------------------------------
		//no1のすべての接続部品についての処理
		//---------------------------------------------------------------
		CanMoveFlagT = 0;
		CanMoveFlagF = 0;

		while (CanMoveFlagT + CanMoveFlagF < parts[no1].pinCount-1) {
			for (j = 0; j < parts[no1].pinCount; j++) {

				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("●部品 %1 のピン %2 に接続されている部品の処理。", no1, parts[no1].pinIndex[j], null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************

				x = xB1;
				y = yB1;
				angle = angleB1;

				srcX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
				srcY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

				x = parts[no1].x;
				y = parts[no1].y;
				angle = parts[no1].a;

				disX2 = rotateX(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);
				disY2 = rotateY(x, y, x+parts[no1].pinX[j], y+parts[no1].pinY[j], angle);

				//-----------------------------------------------------------
				//移動ができなかった場合は、終了
				//-----------------------------------------------------------
				if (partsT[no1].pinType[j] == 0 && no1 != powerPartsIndex) {
					for (pc = 1; pc <= GetPartsNumberForPinIndex(no1, parts[no1].pinIndex[j], 0); pc++) {
						//---------------------------------------------------------------
						//部品情報のＰＵＳＨ（partsP ← parts）
						//---------------------------------------------------------------
						pushPartsArr(partsP);

						//**************  Debug  ****************************************
						if (debugMode == true) {
							MessageString = Format("call CanMove(%1, %2, %3, %4, %5, %6, %7, 1);", no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, null);
							console.log(strTab + MessageString);
						}
						//**************  Debug  ****************************************
						//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
						res = CanMove(no1, parts[no1].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, 1);
						//---------------------------------------------------------------
						//res
						// 0:エラーなし
						// 1:位置が確定できない部品があるため移動できません。
						// 2:固定ピンの影響で移動できません。
						// 3:ロッドの長さが合わないので移動できません。
						// 4:（動かしてみたがだめ）
						// 5:ロッドの長さが合わないので移動できません。
						// 6:ロッドの長さが合わないので移動できません。
						// 7:ロッドの長さが合わないので移動できません。
						// 8:（動かしてみたがだめ）
						// 9:（動かしてみたがだめ）
						//10:複雑すぎて移動できません。
						//---------------------------------------------------------------
						switch (res) {
							//移動成功
	                        case 0:
								CanMoveFlagT++;
								CanMoveFlagF = 0;
								break;
						
							//移動失敗（順序を変えて再挑戦）
	                        case 1:
	                        case 10:
								//---------------------------------------------------------------
								//部品情報のＰＯＰ（parts ← partsP）
								//---------------------------------------------------------------
								popPartsArr(partsP);

								CanMoveFlagF++;
								result = res;
								break;
								
							//移動不可能
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:

								//**************  Debug  ************************************
								if (debugMode == true) {
									MessageString = langConv("移動不能");
									console.log(strTab + MessageString);
									Level = Level - 1;
								}
								//**************  Debug  ************************************

								return res;
						}
					}
				}
			}
		}

		if (CanMoveFlagF > 0) {

			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConv("移動不能");
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			return 11;
		}

		//---------------------------------------------------------------
		//no2のすべての接続部品についての処理
		//---------------------------------------------------------------
		CanMoveFlagT = 0;
		CanMoveFlagF = 0;

		while (CanMoveFlagT + CanMoveFlagF < parts[no2].pinCount-1) {
			for (j = 0; j < parts[no2].pinCount; j++) {

				//**************  Debug  ************************************
				if (debugMode == true) {
					MessageString = langConvFormat("●部品 %1 のピン %2 に接続されている部品の処理。", no2, parts[no2].pinIndex[j], null, null);
					console.log(strTab + MessageString);
				}
				//**************  Debug  ************************************

				x = xB2;
				y = yB2;
				angle = angleB2;
				rr = rB2;

				if (parts[no2].kind == "piston1Power" || parts[no2].kind == "piston2Power" || 
					parts[no2].kind == "piston1" || parts[no2].kind == "piston2") {
					while (rr > 360) {
						rr = rr - 360;
					}
					while (r < 0) {
						rr = rr + 360;
					}
					if (rr > 180) {
						p = 360 - rr;
					} else {
						p = rr;
					}
				} else {
					p = 0;
				}

				srcX2 = rotateX(x, y, x+parts[no2].pinX[j]+p, y+parts[no2].pinY[j], angle);
				srcY2 = rotateY(x, y, x+parts[no2].pinX[j]+p, y+parts[no2].pinY[j], angle);

				x = parts[no2].x;
				y = parts[no2].y
				angle = parts[no2].a;
				rr = parts[no2].r;

				if (parts[no2].kind == "piston1Power" || parts[no2].kind == "piston2Power" || 
					parts[no2].kind == "piston1" || parts[no2].kind == "piston2") {
					while (rr > 360) {
						rr = rr - 360;
					}
					while (r < 0) {
						rr = rr + 360;
					}
					if (rr > 180) {
						p = 360 - rr;
					} else {
						p = rr;
					}
				} else {
					p = 0;
				}

				disX2 = rotateX(x, y, x+parts[no2].pinX[j]+p, y+parts[no2].pinY[j], angle);
				disY2 = rotateY(x, y, x+parts[no2].pinX[j]+p, y+parts[no2].pinY[j], angle);

				//-----------------------------------------------------------
				//移動ができなかった場合は、終了
				//-----------------------------------------------------------
				if (partsT[no2].pinType[j] == 0 && no2 != powerPartsIndex) {
					for (pc = 1; pc <= GetPartsNumberForPinIndex(no2, parts[no2].pinIndex[j], 0); pc++) {
						//---------------------------------------------------------------
						//部品情報のＰＵＳＨ（partsP ← parts）
						//---------------------------------------------------------------
						pushPartsArr(partsP);

						//**************  Debug  ****************************************
						if (debugMode == true) {
							MessageString = Format("call CanMove(%1, %2, %3, %4, %5, %6, %7, 1);", no2, parts[no2].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, null);
							console.log(strTab + MessageString);
						}
						//**************  Debug  ****************************************
						//function CanMove(PartsNo, PinIndex, PartsCount, srcX, srcY, disX, disY, MoveFlag) {
						res = CanMove(no2, parts[no2].pinIndex[j], pc, srcX2, srcY2, disX2, disY2, 1);
						//---------------------------------------------------------------
						//res
						// 0:エラーなし
						// 1:位置が確定できない部品があるため移動できません。
						// 2:固定ピンの影響で移動できません。
						// 3:ロッドの長さが合わないので移動できません。
						// 4:（動かしてみたがだめ）
						// 5:ロッドの長さが合わないので移動できません。
						// 6:ロッドの長さが合わないので移動できません。
						// 7:ロッドの長さが合わないので移動できません。
						// 8:（動かしてみたがだめ）
						// 9:（動かしてみたがだめ）
						//10:複雑すぎて移動できません。
						//---------------------------------------------------------------
						switch (res) {
						
							//移動成功
                        	case 0:
								CanMoveFlagT++;
								CanMoveFlagF = 0;
								break;
							
							//移動失敗（順序を変えて再挑戦）
							case 1:
							case 10:
								//---------------------------------------------------------------
								//部品情報のＰＯＰ（parts ← partsP）
								//---------------------------------------------------------------
								popPartsArr(partsP);

								CanMoveFlagF++;
								Result = res;
								break;
							
							//移動不可能
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:

								//**************  Debug  ************************************
								if (debugMode == true) {
									MessageString = langConv("移動不能");
									console.log(strTab + MessageString);
									Level = Level - 1;
								}
								//**************  Debug  ************************************

								return res;
						}
					}
				}
			}
		}

		if (CanMoveFlagF > 0) {

			//**************  Debug  ************************************
			if (debugMode == true) {
				MessageString = langConv("移動不能");
				console.log(strTab + MessageString);
				Level = Level - 1;
			}
			//**************  Debug  ************************************

			return 11;
		}

		//===============================================================
		//移動処理後の処理
		//===============================================================
//      for j := 0 to intCurrentPartsNumber - 1 do
//        for k := 0 to Parts[j].PinCount-1 do
//          if PartsT[j].PinType[k] = 2 then PartsT[j].PinType[k] := 1;


		result = 0;
		break;

	}

	//===================================================================
	//ここまで　対象のピンに接続されているすべての部品についての処理
	//===================================================================
	//**************  Debug  ********************************************
	if (debugMode == true) {
		MessageString = langConv("移動完了");
		console.log(strTab + MessageString);
		Level = Level - 1;
	}
	//**************  Debug  ********************************************

	return result;
}
